/* *******************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001,2002 Robert Chatley, Alan Chan                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

/*
 * ErrorMsgWriter.java
 */
package com.chatley.kenya;

/**
 * The Type Checker and Data flow analyser take as parameters, objects which
 * this interface.&nbsp;They then use this interface to write all their error
 * messages to.&nbsp;This allows the destination of the error messages to be
 * transparent to the type checker and the data flow analyser.&nbsp;For example,
 * the destination could be standard error, the Kenya IDE or a error log file,
 * and no matter what the destination is, neither the type checker nor data flow
 * analyser need to know about it - they need not hold explict references to the
 * destination.<p>
 *
 * @see StdErrorMsgWriter
 * @see KUIErrorMsgWriter
 */

public interface ErrorMsgWriter
{
    /** Print an error message along with the line number.*/
    public void giveError(String msg, int line);

    /** Print an error message.*/
    public void giveError(String msg);
}