
package com.chatley.kenya;

import com.chatley.kenya.minijava.parser.*;
import com.chatley.kenya.minijava.lexer.*;
import com.chatley.kenya.minijava.node.*;
import java.io.IOException;

public class KParser extends Parser
{
    public KParser(Lexer lexer)
    {
        super(lexer);
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        try{
            return super.parse();
        }catch(ParserException e){
            String msg = e.getMessage();

            int firstComma = msg.indexOf(',');
            String line = msg.substring(1,firstComma);
            String text = msg.substring(msg.indexOf(']')+1);

            // use our own format for error msgs and re-throw exception
            throw new ParserException(e.getToken(),
               "Error: (line " + line + ") " + text);
        }
    }
}
