/* *******************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001,2002 Robert Chatley, Alan Chan                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

/**
 * InterpreterListener.java
 *
 * The code in this class is executed when the 'Interpreter' button
 * is clicked.&nbsp;We pop up and display the kenya interpreter window.
 *
 * @author askc98 2002/2
 */

package com.chatley.kenya.gui;

import java.io.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import com.chatley.kenya.*;
import com.chatley.kenya.utils.IMTrace;

class InterpreterListener implements ActionListener
{

    private KenyaUI mUi;

    InterpreterListener( KenyaUI f )
    {
        mUi = f;
    }

    public void actionPerformed( ActionEvent event )
    {
        IMTrace.out("starting actionPerformed()");
        IMTrace.out("mOutwin == null : " + (mUi.outwin==null));

        if(mUi.outwin!=null)
        {
            IMTrace.out("There is already an interpreter instance running.");
            mUi.outwin.show();
        }
        else
        {
            mUi.outwin = new KOutputWindow(mUi,null);
            mUi.outwin.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e)
                {
                    mUi.msgsArea.setText("");
                    mUi.outwin.dispose();
                    mUi.outwin = null;
                    mUi.removeAllLineHighlights();
                    mUi.clearBreakpoints();
                }
            });
            mUi.outwin.pack();
            mUi.outwin.show();
        }
    }
}

