/* *******************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001,2002 Robert Chatley, Alan Chan                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

/*
 * KenyaTokenMarker.java - Kenya token marker
 * Alan Chan 2002/1
 */

package com.chatley.kenya.gui.syntaxHighlight; // askc98

import com.chatley.kenya.gui.syntaxHighlight.jeditSyntax.*;
import javax.swing.text.Segment;

/**
 * Kenya token marker.
 *
 * @author Alan Chan
 * @version $Id: KenyaTokenMarker.java,v 1.1.1.1 2002/09/09 11:19:29 rbc Exp $
 */
public class KenyaTokenMarker extends CTokenMarker
{
    public KenyaTokenMarker()
    {
        super(false,getKeywords());
    }

    public static KeywordMap getKeywords()
    {
        if(mKenyaKeywords == null)
        {
            mKenyaKeywords = new KeywordMap(false);
            mKenyaKeywords.add("char",Token.KEYWORD1);
            mKenyaKeywords.add("int",Token.KEYWORD1);
            mKenyaKeywords.add("double",Token.KEYWORD1);
            mKenyaKeywords.add("boolean",Token.KEYWORD1);
            mKenyaKeywords.add("void",Token.KEYWORD1);
            mKenyaKeywords.add("class",Token.KEYWORD1);
            mKenyaKeywords.add("break",Token.KEYWORD1);
            mKenyaKeywords.add("case",Token.KEYWORD1);
            mKenyaKeywords.add("default",Token.KEYWORD1);
            mKenyaKeywords.add("else",Token.KEYWORD1);
            mKenyaKeywords.add("for",Token.KEYWORD1);
            mKenyaKeywords.add("if",Token.KEYWORD1);
            mKenyaKeywords.add("new",Token.KEYWORD1);
            mKenyaKeywords.add("return",Token.KEYWORD1);
            mKenyaKeywords.add("switch",Token.KEYWORD1);
            mKenyaKeywords.add("while",Token.KEYWORD1);
            mKenyaKeywords.add("true",Token.KEYWORD1);
            mKenyaKeywords.add("false",Token.KEYWORD1);
            mKenyaKeywords.add("String",Token.KEYWORD1);
            mKenyaKeywords.add("const",Token.KEYWORD1);
            mKenyaKeywords.add("step",Token.KEYWORD1);
            mKenyaKeywords.add("decreasing",Token.KEYWORD1);
            mKenyaKeywords.add("null",Token.KEYWORD1);
            mKenyaKeywords.add("and",Token.KEYWORD1);
            mKenyaKeywords.add("or",Token.KEYWORD1);
            mKenyaKeywords.add("xor",Token.KEYWORD1);
            mKenyaKeywords.add("not",Token.KEYWORD1);
        }
        return mKenyaKeywords;
    }

    // private members
    private static KeywordMap mKenyaKeywords;
}
