/* *******************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001,2002 Robert Chatley, Alan Chan                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

package com.chatley.kenya.interpreter;

import com.chatley.kenya.minijava.analysis.DepthFirstAdapter;
import com.chatley.kenya.minijava.node.*;

/**
 * Simple AST walker. This is simple Abstract Syntax Tree walker
 * which will visit each of the nodes and print on standard output the
 * name of particular node visited. This class can be very usefull while
 * testing the tree structure for a given input. In a nutshell - we print the
 * AST to standard output.
 *
 * @author Alan Chan askc98 2002/2
 */
public class PrintWalker extends DepthFirstAdapter {

  int indent = 0;

  void indent(){
    String s = new String ("");
    for(int i=0; i < indent; i++) s += " ";
    System.out.print(s);
  }

  public void defaultIn(Node node) {
    indent();
    System.out.println(node.getClass().getName().substring("Interpreter".length()+1));
    indent++;
  }

  public void defaultOut(Node node) {
    indent--;
  }

  public void defaultCase(Node node) {
    indent();
    System.out.println(node.getClass().getName().substring("Interpreter".length()+1)+": " + ((Token) node).getText());
  }

}

