/* *******************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001,2002 Robert Chatley, Alan Chan                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

/**
 * Exception class that is the root of exceptions
 * thrown from the Value class. These exceptions are
 * thrown when a Value object is queried for a value
 * of a type it doesn't represent. For example, if an
 * instance of a Value object is supposed to be holding
 * (representing) an int, and it is queried for a String
 * by a call to the getString() method say, a NotAStringException
 * will be thrown.
 * @see Value class
 */

package com.chatley.kenya.interpreter.value;

public class ValueException extends Exception
{
    public ValueException(){}

    public ValueException(String msg)
    {
        super(msg);
    }
}