/* *******************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001,2002 Robert Chatley, Alan Chan                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

/**
 * ValueSwitch.java
 *
 * Allows us to perform an object oriented swtich on Value objects.&nbsp;Used
 * mainly by the variable watch window.&nbsp;All subclasses of Value need to
 * implement this interface, and if more descendants are added in the future,
 * then this interface will need to be modified or subclasses to cater for them.
 *
 * @author Alan Chan 2002/2
 */

package com.chatley.kenya.interpreter.value;

public interface ValueSwitch
{
    public Object caseAArrayValue(ArrayValue v);

    public Object caseAClassValue(ClassValue v);

    public Object caseAStringValue(StringValue v);

    public Object caseAIntValue(IntValue v);

    public Object caseADoubleValue(DoubleValue v);

    public Object caseACharValue(CharValue v);

    public Object caseABoolValue(BoolValue v);

    public Object caseANullValue(NullValue v);
}


