/* This file was generated by SableCC (http://www.sablecc.org/). */

package com.chatley.kenya.minijava.lexer;

import java.io.*;
import java.util.*;
import com.chatley.kenya.minijava.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 85:
                        {
                            Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 86:
                        {
                            Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 87:
                        {
                            Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 88:
                        {
                            Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 89:
                        {
                            Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 90:
                        {
                            Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 91:
                        {
                            Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 92:
                        {
                            Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 93:
                        {
                            Token token = new93(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 94:
                        {
                            Token token = new94(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 95:
                        {
                            Token token = new95(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text, start_line + 1);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TNewLine(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TTraditionalComment(text, line, pos); }
    Token new3(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new4(int line, int pos) { return new TBoolean(line, pos); }
    Token new5(int line, int pos) { return new TChar(line, pos); }
    Token new6(int line, int pos) { return new TInt(line, pos); }
    Token new7(int line, int pos) { return new TReal(line, pos); }
    Token new8(int line, int pos) { return new TString(line, pos); }
    Token new9(int line, int pos) { return new TVoid(line, pos); }
    Token new10(int line, int pos) { return new TKlass(line, pos); }
    Token new11(int line, int pos) { return new TConst(line, pos); }
    Token new12(int line, int pos) { return new TPrint(line, pos); }
    Token new13(int line, int pos) { return new TPrintln(line, pos); }
    Token new14(int line, int pos) { return new TIf(line, pos); }
    Token new15(int line, int pos) { return new TElse(line, pos); }
    Token new16(int line, int pos) { return new TWhile(line, pos); }
    Token new17(int line, int pos) { return new TReturn(line, pos); }
    Token new18(int line, int pos) { return new TSwitch(line, pos); }
    Token new19(int line, int pos) { return new TCase(line, pos); }
    Token new20(int line, int pos) { return new TBreak(line, pos); }
    Token new21(int line, int pos) { return new TDefault(line, pos); }
    Token new22(int line, int pos) { return new TFor(line, pos); }
    Token new23(int line, int pos) { return new TTo(line, pos); }
    Token new24(int line, int pos) { return new TStep(line, pos); }
    Token new25(int line, int pos) { return new TDecreasing(line, pos); }
    Token new26(int line, int pos) { return new TAssert(line, pos); }
    Token new27(int line, int pos) { return new TArraycopy(line, pos); }
    Token new28(int line, int pos) { return new TNew(line, pos); }
    Token new29(int line, int pos) { return new TTrue(line, pos); }
    Token new30(int line, int pos) { return new TFalse(line, pos); }
    Token new31(int line, int pos) { return new TNull(line, pos); }
    Token new32(String text, int line, int pos) { return new TAnd(text, line, pos); }
    Token new33(String text, int line, int pos) { return new TOr(text, line, pos); }
    Token new34(int line, int pos) { return new TXor(line, pos); }
    Token new35(String text, int line, int pos) { return new TNot(text, line, pos); }
    Token new36(int line, int pos) { return new TSin(line, pos); }
    Token new37(int line, int pos) { return new TCos(line, pos); }
    Token new38(int line, int pos) { return new TTan(line, pos); }
    Token new39(int line, int pos) { return new TAsin(line, pos); }
    Token new40(int line, int pos) { return new TAcos(line, pos); }
    Token new41(int line, int pos) { return new TAtan(line, pos); }
    Token new42(int line, int pos) { return new TSqrt(line, pos); }
    Token new43(int line, int pos) { return new TLog(line, pos); }
    Token new44(int line, int pos) { return new TExp(line, pos); }
    Token new45(int line, int pos) { return new TRandom(line, pos); }
    Token new46(int line, int pos) { return new TRound(line, pos); }
    Token new47(int line, int pos) { return new TAbs(line, pos); }
    Token new48(int line, int pos) { return new TFloor(line, pos); }
    Token new49(int line, int pos) { return new TCeil(line, pos); }
    Token new50(int line, int pos) { return new TRead(line, pos); }
    Token new51(int line, int pos) { return new TReadint(line, pos); }
    Token new52(int line, int pos) { return new TReadreal(line, pos); }
    Token new53(int line, int pos) { return new TReadstring(line, pos); }
    Token new54(int line, int pos) { return new TReadchar(line, pos); }
    Token new55(int line, int pos) { return new TEndoffile(line, pos); }
    Token new56(int line, int pos) { return new TDrawbox(line, pos); }
    Token new57(int line, int pos) { return new TDrawtriangle(line, pos); }
    Token new58(int line, int pos) { return new TDrawellipse(line, pos); }
    Token new59(int line, int pos) { return new TDrawline(line, pos); }
    Token new60(int line, int pos) { return new TDrawstring(line, pos); }
    Token new61(int line, int pos) { return new TClear(line, pos); }
    Token new62(int line, int pos) { return new TSetcolour(line, pos); }
    Token new63(int line, int pos) { return new TSetbgcolour(line, pos); }
    Token new64(int line, int pos) { return new TFill(line, pos); }
    Token new65(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new66(String text, int line, int pos) { return new TStringliteral(text, line, pos); }
    Token new67(String text, int line, int pos) { return new TCharliteral(text, line, pos); }
    Token new68(int line, int pos) { return new TLParenthese(line, pos); }
    Token new69(int line, int pos) { return new TRParenthese(line, pos); }
    Token new70(int line, int pos) { return new TLBrace(line, pos); }
    Token new71(int line, int pos) { return new TRBrace(line, pos); }
    Token new72(int line, int pos) { return new TLBracket(line, pos); }
    Token new73(int line, int pos) { return new TRBracket(line, pos); }
    Token new74(String text, int line, int pos) { return new TBracketPair(text, line, pos); }
    Token new75(int line, int pos) { return new TSemicolon(line, pos); }
    Token new76(int line, int pos) { return new TColon(line, pos); }
    Token new77(int line, int pos) { return new TComma(line, pos); }
    Token new78(String text, int line, int pos) { return new TDot(text, line, pos); }
    Token new79(int line, int pos) { return new TPlus(line, pos); }
    Token new80(int line, int pos) { return new TPlusplus(line, pos); }
    Token new81(int line, int pos) { return new TMinus(line, pos); }
    Token new82(int line, int pos) { return new TMinusminus(line, pos); }
    Token new83(int line, int pos) { return new TTimes(line, pos); }
    Token new84(int line, int pos) { return new TDivide(line, pos); }
    Token new85(int line, int pos) { return new TPower(line, pos); }
    Token new86(int line, int pos) { return new TMod(line, pos); }
    Token new87(int line, int pos) { return new TLess(line, pos); }
    Token new88(int line, int pos) { return new TLessequal(line, pos); }
    Token new89(int line, int pos) { return new TGreater(line, pos); }
    Token new90(int line, int pos) { return new TGreaterequal(line, pos); }
    Token new91(int line, int pos) { return new TEqual(line, pos); }
    Token new92(int line, int pos) { return new TNotequal(line, pos); }
    Token new93(int line, int pos) { return new TAssign(line, pos); }
    Token new94(String text, int line, int pos) { return new TIntnumber(text, line, pos); }
    Token new95(String text, int line, int pos) { return new TFpnumber(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 57, 18}, {58, 58, 19}, {59, 59, 20}, {60, 60, 21}, {61, 61, 22}, {62, 62, 23}, {65, 82, 24}, {83, 83, 25}, {84, 90, 24}, {91, 91, 26}, {93, 93, 27}, {94, 94, 28}, {97, 97, 29}, {98, 98, 30}, {99, 99, 31}, {100, 100, 32}, {101, 101, 33}, {102, 102, 34}, {103, 104, 35}, {105, 105, 36}, {106, 107, 35}, {108, 108, 37}, {109, 109, 35}, {110, 110, 38}, {111, 111, 39}, {112, 112, 40}, {113, 113, 35}, {114, 114, 41}, {115, 115, 42}, {116, 116, 43}, {117, 117, 35}, {118, 118, 44}, {119, 119, 45}, {120, 120, 46}, {121, 122, 35}, {123, 123, 47}, {124, 124, 48}, {125, 125, 49}, },
            {{9, 9, 1}, {32, 32, 4}, },
            {},
            {{10, 10, 50}, },
            {{9, 32, -3}, },
            {{61, 61, 51}, },
            {{9, 9, 52}, {32, 33, 52}, {34, 34, 53}, {35, 127, 52}, },
            {},
            {{38, 38, 54}, },
            {{9, 9, 55}, {32, 38, 55}, {40, 91, 55}, {92, 92, 56}, {93, 127, 55}, },
            {},
            {},
            {},
            {{43, 43, 57}, },
            {},
            {{45, 45, 58}, },
            {},
            {{42, 42, 59}, {47, 47, 60}, },
            {{46, 46, 61}, {48, 57, 18}, },
            {},
            {},
            {{61, 61, 62}, },
            {{61, 61, 63}, },
            {{61, 61, 64}, },
            {{48, 57, 65}, {65, 90, 66}, {97, 122, 67}, },
            {{48, 90, -26}, {97, 115, 67}, {116, 116, 68}, {117, 122, 67}, },
            {{32, 32, 69}, {93, 93, 70}, },
            {},
            {},
            {{48, 90, -26}, {97, 97, 67}, {98, 98, 71}, {99, 99, 72}, {100, 109, 67}, {110, 110, 73}, {111, 113, 67}, {114, 114, 74}, {115, 115, 75}, {116, 116, 76}, {117, 122, 67}, },
            {{48, 90, -26}, {97, 110, 67}, {111, 111, 77}, {112, 113, 67}, {114, 114, 78}, {115, 122, 67}, },
            {{48, 90, -26}, {97, 97, 79}, {98, 100, 67}, {101, 101, 80}, {102, 103, 67}, {104, 104, 81}, {105, 107, 67}, {108, 108, 82}, {109, 110, 67}, {111, 111, 83}, {112, 122, 67}, },
            {{48, 90, -26}, {97, 100, 67}, {101, 101, 84}, {102, 110, 67}, {111, 111, 85}, {112, 113, 67}, {114, 114, 86}, {115, 122, 67}, },
            {{48, 90, -26}, {97, 107, 67}, {108, 108, 87}, {109, 119, 67}, {120, 120, 88}, {121, 122, 67}, },
            {{48, 90, -26}, {97, 97, 89}, {98, 104, 67}, {105, 105, 90}, {106, 107, 67}, {108, 108, 91}, {109, 110, 67}, {111, 111, 92}, {112, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 101, 67}, {102, 102, 93}, {103, 109, 67}, {110, 110, 94}, {111, 114, 67}, {115, 115, 95}, {116, 122, 67}, },
            {{48, 110, -32}, {111, 111, 96}, {112, 122, 67}, },
            {{48, 100, -34}, {101, 101, 97}, {102, 110, 67}, {111, 111, 98}, {112, 116, 67}, {117, 117, 99}, {118, 122, 67}, },
            {{48, 90, -26}, {97, 113, 67}, {114, 114, 100}, {115, 122, 67}, },
            {{48, 113, -41}, {114, 114, 101}, {115, 122, 67}, },
            {{48, 90, -26}, {97, 97, 102}, {98, 100, 67}, {101, 101, 103}, {102, 110, 67}, {111, 111, 104}, {112, 122, 67}, },
            {{48, 100, -34}, {101, 101, 105}, {102, 104, 67}, {105, 105, 106}, {106, 112, 67}, {113, 113, 107}, {114, 115, 67}, {116, 116, 108}, {117, 118, 67}, {119, 119, 109}, {120, 122, 67}, },
            {{48, 90, -26}, {97, 97, 110}, {98, 110, 67}, {111, 111, 111}, {112, 113, 67}, {114, 114, 112}, {115, 122, 67}, },
            {{48, 110, -32}, {111, 111, 113}, {112, 122, 67}, },
            {{48, 90, -26}, {97, 103, 67}, {104, 104, 114}, {105, 122, 67}, },
            {{48, 110, -32}, {111, 111, 115}, {112, 122, 67}, },
            {},
            {{124, 124, 116}, },
            {},
            {},
            {},
            {{9, 127, -8}, },
            {},
            {},
            {{39, 39, 117}, },
            {{34, 34, 118}, {39, 39, 119}, {92, 92, 120}, {98, 98, 121}, {102, 102, 122}, {110, 110, 123}, {114, 114, 124}, {116, 116, 125}, },
            {},
            {},
            {{9, 9, 126}, {10, 10, 127}, {13, 13, 128}, {32, 41, 126}, {43, 127, 126}, },
            {{9, 9, 129}, {10, 10, 130}, {13, 13, 131}, {32, 127, 129}, },
            {{48, 57, 132}, },
            {},
            {},
            {},
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 133}, {115, 122, 67}, },
            {{32, 93, -28}, },
            {},
            {{48, 90, -26}, {97, 114, 67}, {115, 115, 134}, {116, 122, 67}, },
            {{48, 110, -32}, {111, 111, 135}, {112, 122, 67}, },
            {{48, 90, -26}, {97, 99, 67}, {100, 100, 136}, {101, 122, 67}, },
            {{48, 113, -41}, {114, 114, 137}, {115, 122, 67}, },
            {{48, 90, -26}, {97, 104, 67}, {105, 105, 138}, {106, 114, 67}, {115, 115, 139}, {116, 122, 67}, },
            {{48, 90, -26}, {97, 97, 140}, {98, 122, 67}, },
            {{48, 110, -32}, {111, 111, 141}, {112, 122, 67}, },
            {{48, 100, -34}, {101, 101, 142}, {102, 122, 67}, },
            {{48, 114, -73}, {115, 115, 143}, {116, 122, 67}, },
            {{48, 104, -77}, {105, 105, 144}, {106, 122, 67}, },
            {{48, 90, -26}, {97, 97, 145}, {98, 122, 67}, },
            {{48, 90, -26}, {97, 97, 146}, {98, 100, 67}, {101, 101, 147}, {102, 122, 67}, },
            {{48, 90, -26}, {97, 109, 67}, {110, 110, 148}, {111, 114, 67}, {115, 115, 149}, {116, 122, 67}, },
            {{48, 90, -26}, {97, 98, 67}, {99, 99, 150}, {100, 101, 67}, {102, 102, 151}, {103, 122, 67}, },
            {{48, 90, -26}, {97, 116, 67}, {117, 117, 152}, {118, 122, 67}, },
            {{48, 90, -26}, {97, 97, 153}, {98, 122, 67}, },
            {{48, 114, -73}, {115, 115, 154}, {116, 122, 67}, },
            {{48, 90, -26}, {97, 111, 67}, {112, 112, 155}, {113, 122, 67}, },
            {{48, 107, -35}, {108, 108, 156}, {109, 122, 67}, },
            {{48, 107, -35}, {108, 108, 157}, {109, 122, 67}, },
            {{48, 110, -32}, {111, 111, 158}, {112, 122, 67}, },
            {{48, 113, -41}, {114, 114, 159}, {115, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 115, -27}, {116, 116, 160}, {117, 122, 67}, },
            {{48, 57, 65}, {65, 68, 66}, {69, 69, 161}, {70, 90, 66}, {97, 122, 67}, },
            {{48, 90, -26}, {97, 102, 67}, {103, 103, 162}, {104, 122, 67}, },
            {{48, 90, -26}, {97, 118, 67}, {119, 119, 163}, {120, 122, 67}, },
            {{48, 115, -27}, {116, 116, 164}, {117, 122, 67}, },
            {{48, 107, -35}, {108, 108, 165}, {109, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 104, -77}, {105, 105, 166}, {106, 122, 67}, },
            {{48, 109, -85}, {110, 110, 167}, {111, 122, 67}, },
            {{48, 90, -26}, {97, 97, 168}, {98, 115, 67}, {116, 116, 169}, {117, 122, 67}, },
            {{48, 116, -87}, {117, 117, 170}, {118, 122, 67}, },
            {{48, 115, -27}, {116, 116, 171}, {117, 122, 67}, },
            {{48, 109, -85}, {110, 110, 172}, {111, 122, 67}, },
            {{48, 113, -41}, {114, 114, 173}, {115, 122, 67}, },
            {{48, 100, -34}, {101, 101, 174}, {102, 122, 67}, },
            {{48, 104, -77}, {105, 105, 175}, {106, 122, 67}, },
            {{48, 109, -85}, {110, 110, 176}, {111, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 116, -87}, {117, 117, 177}, {118, 122, 67}, },
            {{48, 104, -77}, {105, 105, 178}, {106, 122, 67}, },
            {{48, 104, -77}, {105, 105, 179}, {106, 122, 67}, },
            {{48, 113, -41}, {114, 114, 180}, {115, 122, 67}, },
            {},
            {},
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{39, 39, 181}, },
            {{9, 41, -61}, {42, 42, 182}, {43, 127, 126}, },
            {{9, 127, -128}, },
            {{9, 9, 126}, {10, 10, 183}, {13, 127, -128}, },
            {{9, 127, -62}, },
            {},
            {{10, 10, 184}, },
            {{48, 57, 132}, },
            {{48, 104, -77}, {105, 105, 185}, {106, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 114, -73}, {115, 115, 186}, {116, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 97, 187}, {98, 122, 67}, },
            {{48, 109, -85}, {110, 110, 188}, {111, 122, 67}, },
            {{48, 100, -34}, {101, 101, 189}, {102, 122, 67}, },
            {{48, 109, -85}, {110, 110, 190}, {111, 122, 67}, },
            {{48, 107, -35}, {108, 108, 191}, {109, 122, 67}, },
            {{48, 90, -26}, {97, 97, 192}, {98, 122, 67}, },
            {{48, 100, -34}, {101, 101, 193}, {102, 122, 67}, },
            {{48, 107, -35}, {108, 108, 194}, {109, 122, 67}, },
            {{48, 113, -41}, {114, 114, 195}, {115, 122, 67}, },
            {{48, 114, -73}, {115, 115, 196}, {116, 122, 67}, },
            {{48, 90, -26}, {97, 97, 197}, {98, 122, 67}, },
            {{48, 114, -73}, {115, 115, 198}, {116, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 199}, {115, 122, 67}, },
            {{48, 90, -26}, {97, 97, 200}, {98, 122, 67}, },
            {{48, 97, -31}, {98, 98, 201}, {99, 122, 67}, },
            {{48, 118, -99}, {119, 119, 202}, {120, 122, 67}, },
            {{48, 100, -34}, {101, 101, 203}, {102, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 114, -73}, {115, 115, 204}, {116, 122, 67}, },
            {{48, 107, -35}, {108, 108, 205}, {109, 122, 67}, },
            {{48, 110, -32}, {111, 111, 206}, {112, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 57, 65}, {65, 78, 66}, {79, 79, 207}, {80, 90, 66}, {97, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 208}, {109, 122, 67}, },
            {{48, 109, -85}, {110, 110, 209}, {111, 122, 67}, },
            {{48, 99, -75}, {100, 100, 210}, {101, 122, 67}, },
            {{48, 99, -75}, {100, 100, 211}, {101, 122, 67}, },
            {{48, 116, -87}, {117, 117, 212}, {118, 122, 67}, },
            {{48, 109, -85}, {110, 110, 213}, {111, 122, 67}, },
            {{48, 57, 65}, {65, 65, 66}, {66, 66, 214}, {67, 67, 215}, {68, 90, 66}, {97, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 115, -27}, {116, 116, 216}, {117, 122, 67}, },
            {{48, 111, -90}, {112, 112, 217}, {113, 122, 67}, },
            {{48, 115, -27}, {116, 116, 218}, {117, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 219}, {102, 122, 67}, },
            {{48, 99, -75}, {100, 100, 220}, {101, 122, 67}, },
            {{48, 107, -35}, {108, 108, 221}, {109, 122, 67}, },
            {{48, 122, -26}, },
            {},
            {{9, 9, 222}, {10, 10, 223}, {13, 13, 224}, {32, 41, 222}, {42, 42, 182}, {43, 46, 222}, {47, 47, 225}, {48, 127, 222}, },
            {{9, 127, -128}, },
            {},
            {{48, 109, -85}, {110, 110, 226}, {111, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 120, 67}, {121, 121, 227}, {122, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 228}, {115, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 229}, {102, 122, 67}, },
            {{48, 90, -26}, {97, 106, 67}, {107, 107, 230}, {108, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 114, -73}, {115, 115, 231}, {116, 122, 67}, },
            {{48, 113, -41}, {114, 114, 232}, {115, 122, 67}, },
            {{48, 115, -27}, {116, 116, 233}, {117, 122, 67}, },
            {{48, 100, -34}, {101, 101, 234}, {102, 122, 67}, },
            {{48, 116, -87}, {117, 117, 235}, {118, 122, 67}, },
            {{48, 107, -35}, {108, 108, 236}, {109, 122, 67}, },
            {{48, 65, -173}, {66, 66, 237}, {67, 68, 66}, {69, 69, 238}, {70, 75, 66}, {76, 76, 239}, {77, 82, 66}, {83, 83, 240}, {84, 84, 241}, {85, 90, 66}, {97, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 242}, {102, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 243}, {115, 122, 67}, },
            {{48, 57, 65}, {65, 69, 66}, {70, 70, 244}, {71, 90, 66}, {97, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 115, -27}, {116, 116, 245}, {117, 122, 67}, },
            {{48, 110, -32}, {111, 111, 246}, {112, 122, 67}, },
            {{40, 40, 247}, {48, 57, 65}, {65, 66, 66}, {67, 67, 248}, {68, 68, 249}, {69, 72, 66}, {73, 73, 250}, {74, 82, 66}, {83, 83, 251}, {84, 90, 66}, {97, 122, 67}, },
            {{48, 113, -41}, {114, 114, 252}, {115, 122, 67}, },
            {{48, 99, -75}, {100, 100, 253}, {101, 122, 67}, },
            {{48, 57, 65}, {65, 70, 66}, {71, 71, 254}, {72, 90, 66}, {97, 122, 67}, },
            {{48, 110, -32}, {111, 111, 255}, {112, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 98, -86}, {99, 99, 256}, {100, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 257}, {102, 122, 67}, },
            {{9, 9, 258}, {10, 10, 259}, {13, 13, 260}, {32, 41, 258}, {42, 42, 261}, {43, 127, 258}, },
            {{9, 127, -224}, },
            {{9, 9, 258}, {10, 10, 262}, {13, 127, -224}, },
            {},
            {{48, 102, -98}, {103, 103, 263}, {104, 122, 67}, },
            {{48, 98, -86}, {99, 99, 264}, {100, 122, 67}, },
            {{48, 115, -27}, {116, 116, 265}, {117, 122, 67}, },
            {{48, 90, -26}, {97, 97, 266}, {98, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{40, 40, 267}, {48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 97, 268}, {98, 122, 67}, },
            {{48, 107, -35}, {108, 108, 269}, {109, 122, 67}, },
            {{48, 100, -34}, {101, 101, 270}, {102, 122, 67}, },
            {{48, 110, -32}, {111, 111, 271}, {112, 122, 67}, },
            {{48, 107, -35}, {108, 108, 272}, {109, 122, 67}, },
            {{48, 104, -77}, {105, 105, 273}, {106, 122, 67}, },
            {{48, 115, -27}, {116, 116, 274}, {117, 122, 67}, },
            {{48, 113, -41}, {114, 114, 275}, {115, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{40, 40, 276}, {48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 277}, {109, 122, 67}, },
            {{48, 90, -26}, {97, 108, 67}, {109, 109, 278}, {110, 122, 67}, },
            {{41, 41, 279}, },
            {{48, 103, -47}, {104, 104, 280}, {105, 122, 67}, },
            {{48, 110, -32}, {111, 111, 281}, {112, 122, 67}, },
            {{48, 109, -85}, {110, 110, 282}, {111, 122, 67}, },
            {{48, 115, -27}, {116, 116, 283}, {117, 122, 67}, },
            {{48, 109, -85}, {110, 110, 284}, {111, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 66, -213}, {67, 67, 285}, {68, 122, -173}, },
            {{48, 107, -35}, {108, 108, 286}, {109, 122, 67}, },
            {{48, 103, -47}, {104, 104, 287}, {105, 122, 67}, },
            {{48, 122, -26}, },
            {{9, 127, -224}, },
            {{9, 127, -224}, },
            {{9, 9, 258}, {10, 10, 288}, {13, 127, -224}, },
            {{9, 41, -184}, {42, 42, 261}, {43, 127, -184}, },
            {{9, 127, -224}, },
            {{48, 122, -26}, },
            {{48, 110, -32}, {111, 111, 289}, {112, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 109, -85}, {110, 110, 290}, {111, 122, 67}, },
            {{41, 41, 291}, },
            {{48, 114, -73}, {115, 115, 292}, {116, 122, 67}, },
            {{48, 115, -27}, {116, 116, 293}, {117, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 119, 67}, {120, 120, 294}, {121, 122, 67}, },
            {{48, 107, -35}, {108, 108, 295}, {109, 122, 67}, },
            {{48, 109, -85}, {110, 110, 296}, {111, 122, 67}, },
            {{48, 113, -41}, {114, 114, 297}, {115, 122, 67}, },
            {{48, 104, -77}, {105, 105, 298}, {106, 122, 67}, },
            {{41, 41, 299}, },
            {{48, 109, -85}, {110, 110, 300}, {111, 122, 67}, },
            {{48, 122, -26}, },
            {},
            {{48, 90, -26}, {97, 97, 301}, {98, 122, 67}, },
            {{48, 116, -87}, {117, 117, 302}, {118, 122, 67}, },
            {{48, 115, -27}, {116, 116, 303}, {117, 122, 67}, },
            {{48, 113, -41}, {114, 114, 304}, {115, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 110, -32}, {111, 111, 305}, {112, 122, 67}, },
            {{48, 110, -32}, {111, 111, 306}, {112, 122, 67}, },
            {{48, 122, -26}, },
            {{9, 127, -224}, },
            {{48, 111, -90}, {112, 112, 307}, {113, 122, 67}, },
            {{48, 122, -26}, },
            {},
            {{48, 104, -77}, {105, 105, 308}, {106, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 104, -77}, {105, 105, 309}, {106, 122, 67}, },
            {{48, 100, -34}, {101, 101, 310}, {102, 122, 67}, },
            {{48, 104, -77}, {105, 105, 311}, {106, 122, 67}, },
            {{48, 90, -26}, {97, 97, 312}, {98, 122, 67}, },
            {},
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 313}, {115, 122, 67}, },
            {{48, 97, -31}, {98, 98, 314}, {99, 122, 67}, },
            {{40, 40, 315}, {48, 122, -26}, },
            {{48, 104, -77}, {105, 105, 316}, {106, 122, 67}, },
            {{48, 107, -35}, {108, 108, 317}, {109, 122, 67}, },
            {{48, 116, -87}, {117, 117, 318}, {118, 122, 67}, },
            {{48, 120, -189}, {121, 121, 319}, {122, 122, 67}, },
            {{48, 109, -85}, {110, 110, 320}, {111, 122, 67}, },
            {{48, 111, -90}, {112, 112, 321}, {113, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 109, -85}, {110, 110, 322}, {111, 122, 67}, },
            {{48, 109, -85}, {110, 110, 323}, {111, 122, 67}, },
            {{40, 40, 324}, {48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 325}, {109, 122, 67}, },
            {{41, 41, 326}, },
            {{48, 109, -85}, {110, 110, 327}, {111, 122, 67}, },
            {{48, 110, -32}, {111, 111, 328}, {112, 122, 67}, },
            {{48, 113, -41}, {114, 114, 329}, {115, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 102, -98}, {103, 103, 330}, {104, 122, 67}, },
            {{48, 114, -73}, {115, 115, 331}, {116, 122, 67}, },
            {{48, 102, -98}, {103, 103, 332}, {104, 122, 67}, },
            {{48, 102, -98}, {103, 103, 333}, {104, 122, 67}, },
            {{41, 41, 334}, },
            {{48, 100, -34}, {101, 101, 335}, {102, 122, 67}, },
            {},
            {{48, 102, -98}, {103, 103, 336}, {104, 122, 67}, },
            {{48, 116, -87}, {117, 117, 337}, {118, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 338}, {102, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 339}, {109, 122, 67}, },
            {},
            {{40, 40, 340}, {48, 122, -26}, },
            {{40, 40, 341}, {48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 342}, {115, 122, 67}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 343}, {102, 122, 67}, },
            {{41, 41, 344}, },
            {{41, 41, 345}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 1, 0, 0, 1, 35, -1, 86, -1, -1, 68, 69, 83, 79, 77, 81, 78, 84, 94, 76, 75, 87, 93, 89, 65, 65, 72, 73, 85, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 70, -1, 71, 0, 92, -1, 66, 32, -1, -1, 80, 82, -1, 3, -1, 88, 91, 90, 65, 65, 65, 65, -1, 74, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 14, 65, 65, 65, 65, 65, 65, 33, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 23, 65, 65, 65, 65, 33, 67, -1, 67, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 3, 3, 95, 65, 47, 65, 32, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 37, 65, 65, 65, 65, 65, 44, 65, 65, 65, 22, 6, 65, 43, 28, 35, 65, 65, 65, 65, 65, 65, 65, 36, 65, 65, 65, 38, 65, 65, 65, 34, 67, -1, -1, 3, 65, 40, 65, 39, 65, 41, 65, 65, 19, 49, 5, 65, 65, 65, 65, 65, 65, 65, 15, 65, 64, 65, 65, 31, 65, 65, 65, 65, 65, 65, 65, 42, 24, 65, 29, 9, 65, -1, -1, -1, 2, 65, 65, 65, 65, 20, 10, 65, 11, 65, 65, 65, 65, 65, 65, 65, 65, 30, 48, 65, 12, 65, -1, 65, 65, 65, 65, 65, 46, 65, 65, 65, 16, -1, -1, -1, -1, -1, 8, 65, 26, 65, -1, 65, 65, 7, 65, 65, 65, 65, 65, -1, 65, 45, 50, 65, 65, 65, 65, 17, 65, 65, 18, -1, 65, 4, 61, 65, 21, 56, 65, 65, 65, 65, 55, 13, 65, 65, 65, 65, 65, 65, 65, 65, 65, 59, 65, 65, 65, 65, -1, 65, 65, 65, 27, 65, 65, 65, 65, -1, 65, 51, 65, 65, 62, 25, 65, 60, 65, 54, 65, 65, 65, 58, 65, -1, -1, 63, 57, 52, 53, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
