/* This file was generated by SableCC (http://www.sablecc.org/). */

package com.chatley.kenya.minijava.parser;

import com.chatley.kenya.minijava.lexer.*;
import com.chatley.kenya.minijava.node.*;
import com.chatley.kenya.minijava.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(1), node, true); } break;
                    case 3: { Node node = new3(); push(goTo(1), node, true); } break;
                    case 4: { Node node = new4(); push(goTo(1), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(1), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(1), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(1), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(1), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(1), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(1), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(1), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(1), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(1), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(1), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(1), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(1), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(1), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(1), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(1), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(1), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(1), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(1), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(1), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(1), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(1), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(1), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(1), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(1), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(2), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(2), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(2), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(2), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(2), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(3), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(4), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(5), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(6), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(6), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(6), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(7), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(8), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(9), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(10), node, true); } break;
                    case 44: { Node node = new44(); push(goTo(10), node, true); } break;
                    case 45: { Node node = new45(); push(goTo(53), node, false); } break;
                    case 46: { Node node = new46(); push(goTo(53), node, false); } break;
                    case 47: { Node node = new47(); push(goTo(11), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(12), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(12), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(13), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(13), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(54), node, false); } break;
                    case 53: { Node node = new53(); push(goTo(54), node, false); } break;
                    case 54: { Node node = new54(); push(goTo(13), node, true); } break;
                    case 55: { Node node = new55(); push(goTo(13), node, true); } break;
                    case 56: { Node node = new56(); push(goTo(55), node, false); } break;
                    case 57: { Node node = new57(); push(goTo(55), node, false); } break;
                    case 58: { Node node = new58(); push(goTo(13), node, true); } break;
                    case 59: { Node node = new59(); push(goTo(13), node, true); } break;
                    case 60: { Node node = new60(); push(goTo(13), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(13), node, true); } break;
                    case 62: { Node node = new62(); push(goTo(13), node, true); } break;
                    case 63: { Node node = new63(); push(goTo(13), node, true); } break;
                    case 64: { Node node = new64(); push(goTo(13), node, true); } break;
                    case 65: { Node node = new65(); push(goTo(13), node, true); } break;
                    case 66: { Node node = new66(); push(goTo(13), node, true); } break;
                    case 67: { Node node = new67(); push(goTo(14), node, true); } break;
                    case 68: { Node node = new68(); push(goTo(14), node, true); } break;
                    case 69: { Node node = new69(); push(goTo(56), node, false); } break;
                    case 70: { Node node = new70(); push(goTo(56), node, false); } break;
                    case 71: { Node node = new71(); push(goTo(15), node, true); } break;
                    case 72: { Node node = new72(); push(goTo(15), node, true); } break;
                    case 73: { Node node = new73(); push(goTo(16), node, true); } break;
                    case 74: { Node node = new74(); push(goTo(17), node, true); } break;
                    case 75: { Node node = new75(); push(goTo(18), node, true); } break;
                    case 76: { Node node = new76(); push(goTo(18), node, true); } break;
                    case 77: { Node node = new77(); push(goTo(19), node, true); } break;
                    case 78: { Node node = new78(); push(goTo(20), node, true); } break;
                    case 79: { Node node = new79(); push(goTo(20), node, true); } break;
                    case 80: { Node node = new80(); push(goTo(57), node, false); } break;
                    case 81: { Node node = new81(); push(goTo(57), node, false); } break;
                    case 82: { Node node = new82(); push(goTo(20), node, true); } break;
                    case 83: { Node node = new83(); push(goTo(20), node, true); } break;
                    case 84: { Node node = new84(); push(goTo(58), node, false); } break;
                    case 85: { Node node = new85(); push(goTo(58), node, false); } break;
                    case 86: { Node node = new86(); push(goTo(21), node, true); } break;
                    case 87: { Node node = new87(); push(goTo(22), node, true); } break;
                    case 88: { Node node = new88(); push(goTo(23), node, true); } break;
                    case 89: { Node node = new89(); push(goTo(24), node, true); } break;
                    case 90: { Node node = new90(); push(goTo(24), node, true); } break;
                    case 91: { Node node = new91(); push(goTo(25), node, true); } break;
                    case 92: { Node node = new92(); push(goTo(25), node, true); } break;
                    case 93: { Node node = new93(); push(goTo(26), node, true); } break;
                    case 94: { Node node = new94(); push(goTo(26), node, true); } break;
                    case 95: { Node node = new95(); push(goTo(26), node, true); } break;
                    case 96: { Node node = new96(); push(goTo(26), node, true); } break;
                    case 97: { Node node = new97(); push(goTo(26), node, true); } break;
                    case 98: { Node node = new98(); push(goTo(26), node, true); } break;
                    case 99: { Node node = new99(); push(goTo(27), node, true); } break;
                    case 100: { Node node = new100(); push(goTo(28), node, true); } break;
                    case 101: { Node node = new101(); push(goTo(29), node, true); } break;
                    case 102: { Node node = new102(); push(goTo(30), node, true); } break;
                    case 103: { Node node = new103(); push(goTo(30), node, true); } break;
                    case 104: { Node node = new104(); push(goTo(59), node, false); } break;
                    case 105: { Node node = new105(); push(goTo(59), node, false); } break;
                    case 106: { Node node = new106(); push(goTo(31), node, true); } break;
                    case 107: { Node node = new107(); push(goTo(32), node, true); } break;
                    case 108: { Node node = new108(); push(goTo(32), node, true); } break;
                    case 109: { Node node = new109(); push(goTo(33), node, true); } break;
                    case 110: { Node node = new110(); push(goTo(60), node, false); } break;
                    case 111: { Node node = new111(); push(goTo(60), node, false); } break;
                    case 112: { Node node = new112(); push(goTo(33), node, true); } break;
                    case 113: { Node node = new113(); push(goTo(34), node, true); } break;
                    case 114: { Node node = new114(); push(goTo(34), node, true); } break;
                    case 115: { Node node = new115(); push(goTo(34), node, true); } break;
                    case 116: { Node node = new116(); push(goTo(35), node, true); } break;
                    case 117: { Node node = new117(); push(goTo(35), node, true); } break;
                    case 118: { Node node = new118(); push(goTo(35), node, true); } break;
                    case 119: { Node node = new119(); push(goTo(35), node, true); } break;
                    case 120: { Node node = new120(); push(goTo(35), node, true); } break;
                    case 121: { Node node = new121(); push(goTo(36), node, true); } break;
                    case 122: { Node node = new122(); push(goTo(36), node, true); } break;
                    case 123: { Node node = new123(); push(goTo(36), node, true); } break;
                    case 124: { Node node = new124(); push(goTo(36), node, true); } break;
                    case 125: { Node node = new125(); push(goTo(36), node, true); } break;
                    case 126: { Node node = new126(); push(goTo(36), node, true); } break;
                    case 127: { Node node = new127(); push(goTo(37), node, true); } break;
                    case 128: { Node node = new128(); push(goTo(37), node, true); } break;
                    case 129: { Node node = new129(); push(goTo(37), node, true); } break;
                    case 130: { Node node = new130(); push(goTo(38), node, true); } break;
                    case 131: { Node node = new131(); push(goTo(39), node, true); } break;
                    case 132: { Node node = new132(); push(goTo(40), node, true); } break;
                    case 133: { Node node = new133(); push(goTo(41), node, true); } break;
                    case 134: { Node node = new134(); push(goTo(42), node, true); } break;
                    case 135: { Node node = new135(); push(goTo(42), node, true); } break;
                    case 136: { Node node = new136(); push(goTo(42), node, true); } break;
                    case 137: { Node node = new137(); push(goTo(42), node, true); } break;
                    case 138: { Node node = new138(); push(goTo(42), node, true); } break;
                    case 139: { Node node = new139(); push(goTo(42), node, true); } break;
                    case 140: { Node node = new140(); push(goTo(42), node, true); } break;
                    case 141: { Node node = new141(); push(goTo(42), node, true); } break;
                    case 142: { Node node = new142(); push(goTo(42), node, true); } break;
                    case 143: { Node node = new143(); push(goTo(42), node, true); } break;
                    case 144: { Node node = new144(); push(goTo(42), node, true); } break;
                    case 145: { Node node = new145(); push(goTo(42), node, true); } break;
                    case 146: { Node node = new146(); push(goTo(42), node, true); } break;
                    case 147: { Node node = new147(); push(goTo(42), node, true); } break;
                    case 148: { Node node = new148(); push(goTo(42), node, true); } break;
                    case 149: { Node node = new149(); push(goTo(42), node, true); } break;
                    case 150: { Node node = new150(); push(goTo(42), node, true); } break;
                    case 151: { Node node = new151(); push(goTo(42), node, true); } break;
                    case 152: { Node node = new152(); push(goTo(42), node, true); } break;
                    case 153: { Node node = new153(); push(goTo(42), node, true); } break;
                    case 154: { Node node = new154(); push(goTo(42), node, true); } break;
                    case 155: { Node node = new155(); push(goTo(42), node, true); } break;
                    case 156: { Node node = new156(); push(goTo(42), node, true); } break;
                    case 157: { Node node = new157(); push(goTo(42), node, true); } break;
                    case 158: { Node node = new158(); push(goTo(42), node, true); } break;
                    case 159: { Node node = new159(); push(goTo(42), node, true); } break;
                    case 160: { Node node = new160(); push(goTo(42), node, true); } break;
                    case 161: { Node node = new161(); push(goTo(42), node, true); } break;
                    case 162: { Node node = new162(); push(goTo(43), node, true); } break;
                    case 163: { Node node = new163(); push(goTo(43), node, true); } break;
                    case 164: { Node node = new164(); push(goTo(44), node, true); } break;
                    case 165: { Node node = new165(); push(goTo(44), node, true); } break;
                    case 166: { Node node = new166(); push(goTo(44), node, true); } break;
                    case 167: { Node node = new167(); push(goTo(45), node, true); } break;
                    case 168: { Node node = new168(); push(goTo(45), node, true); } break;
                    case 169: { Node node = new169(); push(goTo(46), node, true); } break;
                    case 170: { Node node = new170(); push(goTo(46), node, true); } break;
                    case 171: { Node node = new171(); push(goTo(46), node, true); } break;
                    case 172: { Node node = new172(); push(goTo(47), node, true); } break;
                    case 173: { Node node = new173(); push(goTo(47), node, true); } break;
                    case 174: { Node node = new174(); push(goTo(47), node, true); } break;
                    case 175: { Node node = new175(); push(goTo(47), node, true); } break;
                    case 176: { Node node = new176(); push(goTo(47), node, true); } break;
                    case 177: { Node node = new177(); push(goTo(48), node, true); } break;
                    case 178: { Node node = new178(); push(goTo(48), node, true); } break;
                    case 179: { Node node = new179(); push(goTo(49), node, true); } break;
                    case 180: { Node node = new180(); push(goTo(49), node, true); } break;
                    case 181: { Node node = new181(); push(goTo(50), node, true); } break;
                    case 182: { Node node = new182(); push(goTo(51), node, true); } break;
                    case 183: { Node node = new183(); push(goTo(52), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PStatements node1 = (PStatements) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    /*throw new ParserException(last_token,
                        "Error: (line " + last_line + ") " +
                        errorMessages[errors[action[1]]]);*/

                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PStatements node2 = (PStatements) pop();
        PStatement node1 = (PStatement) pop();
        AListStatements node = new AListStatements(node1, node2);
        return node;
    }

    Node new1()
    {
        AEmptyStatements node = new AEmptyStatements();
        return node;
    }

    Node new2()
    {
        PDeclaration node1 = (PDeclaration) pop();
        ADecStatement node = new ADecStatement(node1);
        return node;
    }

    Node new3()
    {
        TSemicolon node2 = (TSemicolon) pop();
        PFunctionApplication node1 = (PFunctionApplication) pop();
        AFunctioncallStatement node = new AFunctioncallStatement(node1, node2);
        return node;
    }

    Node new4()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PExpression node3 = (PExpression) pop();
        TAssign node2 = (TAssign) pop();
        PFieldAccess node1 = (PFieldAccess) pop();
        AAssignmentStatement node = new AAssignmentStatement(node1, node2, node3, node4);
        return node;
    }

    Node new5()
    {
        PBlock node7 = null;
        TElse node6 = null;
        PBlock node5 = (PBlock) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PBoolExpression node3 = (PBoolExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TIf node1 = (TIf) pop();
        AIfStatement node = new AIfStatement(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new6()
    {
        PBlock node7 = null;
        TElse node6 = (TElse) pop();
        PBlock node5 = (PBlock) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PBoolExpression node3 = (PBoolExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TIf node1 = (TIf) pop();
        AIfStatement node = new AIfStatement(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new7()
    {
        PBlock node7 = (PBlock) pop();
        TElse node6 = null;
        PBlock node5 = (PBlock) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PBoolExpression node3 = (PBoolExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TIf node1 = (TIf) pop();
        AIfStatement node = new AIfStatement(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new8()
    {
        PBlock node7 = (PBlock) pop();
        TElse node6 = (TElse) pop();
        PBlock node5 = (PBlock) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PBoolExpression node3 = (PBoolExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TIf node1 = (TIf) pop();
        AIfStatement node = new AIfStatement(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new9()
    {
        PBlock node5 = (PBlock) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PBoolExpression node3 = (PBoolExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TWhile node1 = (TWhile) pop();
        AWhileStatement node = new AWhileStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new10()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PExpression node2 = null;
        TReturn node1 = (TReturn) pop();
        AReturnStatement node = new AReturnStatement(node1, node2, node3);
        return node;
    }

    Node new11()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PExpression node2 = (PExpression) pop();
        TReturn node1 = (TReturn) pop();
        AReturnStatement node = new AReturnStatement(node1, node2, node3);
        return node;
    }

    Node new12()
    {
        PSwitchBlock node5 = (PSwitchBlock) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PExpression node3 = (PExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TSwitch node1 = (TSwitch) pop();
        ASwitchStatement node = new ASwitchStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new13()
    {
        PBlock node3 = (PBlock) pop();
        PForControl node2 = (PForControl) pop();
        TFor node1 = (TFor) pop();
        AForStatement node = new AForStatement(node1, node2, node3);
        return node;
    }

    Node new14()
    {
        TSemicolon node2 = (TSemicolon) pop();
        TBreak node1 = (TBreak) pop();
        ABreakStatement node = new ABreakStatement(node1, node2);
        return node;
    }

    Node new15()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PExpression node3 = (PExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TPrint node1 = (TPrint) pop();
        APrintStrStatement node = new APrintStrStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new16()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PExpression node3 = (PExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TPrintln node1 = (TPrintln) pop();
        APrintlnStrStatement node = new APrintlnStrStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new17()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PColonString node3 = null;
        PBoolExpression node2 = (PBoolExpression) pop();
        TAssert node1 = (TAssert) pop();
        AAssertStatement node = new AAssertStatement(node1, node2, node3, node4);
        return node;
    }

    Node new18()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PColonString node3 = (PColonString) pop();
        PBoolExpression node2 = (PBoolExpression) pop();
        TAssert node1 = (TAssert) pop();
        AAssertStatement node = new AAssertStatement(node1, node2, node3, node4);
        return node;
    }

    Node new19()
    {
        TSemicolon node7 = (TSemicolon) pop();
        TRParenthese node6 = (TRParenthese) pop();
        PName node5 = (PName) pop();
        TComma node4 = (TComma) pop();
        PName node3 = (PName) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TArraycopy node1 = (TArraycopy) pop();
        AArraycopyStatement node = new AArraycopyStatement(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new20()
    {
        TSemicolon node2 = (TSemicolon) pop();
        TClear node1 = (TClear) pop();
        AClearStatement node = new AClearStatement(node1, node2);
        return node;
    }

    Node new21()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PFourNumbers node3 = (PFourNumbers) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TDrawline node1 = (TDrawline) pop();
        ADrawlineStatement node = new ADrawlineStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new22()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PFourNumbers node3 = (PFourNumbers) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TDrawbox node1 = (TDrawbox) pop();
        ADrawboxStatement node = new ADrawboxStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new23()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PSixNumbers node3 = (PSixNumbers) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TDrawtriangle node1 = (TDrawtriangle) pop();
        ADrawtriangleStatement node = new ADrawtriangleStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new24()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PFourNumbers node3 = (PFourNumbers) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TDrawellipse node1 = (TDrawellipse) pop();
        ADrawellipseStatement node = new ADrawellipseStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new25()
    {
        TSemicolon node9 = (TSemicolon) pop();
        TRParenthese node8 = (TRParenthese) pop();
        PExpression node7 = (PExpression) pop();
        TComma node6 = (TComma) pop();
        PExpression node5 = (PExpression) pop();
        TComma node4 = (TComma) pop();
        PExpression node3 = (PExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TDrawstring node1 = (TDrawstring) pop();
        ADrawstringStatement node = new ADrawstringStatement(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new26()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PRgb node3 = (PRgb) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TSetcolour node1 = (TSetcolour) pop();
        ASetcolourStatement node = new ASetcolourStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new27()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PRgb node3 = (PRgb) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TSetbgcolour node1 = (TSetbgcolour) pop();
        ASetbgcolourStatement node = new ASetbgcolourStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new28()
    {
        TSemicolon node5 = (TSemicolon) pop();
        TRParenthese node4 = (TRParenthese) pop();
        PBoolExpression node3 = (PBoolExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TFill node1 = (TFill) pop();
        AFillStatement node = new AFillStatement(node1, node2, node3, node4, node5);
        return node;
    }

    Node new29()
    {
        TRParenthese node9 = (TRParenthese) pop();
        PUnaryExp node8 = (PUnaryExp) pop();
        TSemicolon node7 = (TSemicolon) pop();
        PBoolExpression node6 = (PBoolExpression) pop();
        TSemicolon node5 = (TSemicolon) pop();
        PExpression node4 = (PExpression) pop();
        TAssign node3 = (TAssign) pop();
        PName node2 = (PName) pop();
        TLParenthese node1 = (TLParenthese) pop();
        AJavaForControl node = new AJavaForControl(node1, node2, node3, node4, node5, node6, node7, node8, node9);
        return node;
    }

    Node new30()
    {
        PStepBit node7 = null;
        PExpression node6 = (PExpression) pop();
        TTo node5 = (TTo) pop();
        PExpression node4 = (PExpression) pop();
        TAssign node3 = (TAssign) pop();
        PName node2 = (PName) pop();
        TDecreasing node1 = null;
        ASimpleForControl node = new ASimpleForControl(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new31()
    {
        PStepBit node7 = null;
        PExpression node6 = (PExpression) pop();
        TTo node5 = (TTo) pop();
        PExpression node4 = (PExpression) pop();
        TAssign node3 = (TAssign) pop();
        PName node2 = (PName) pop();
        TDecreasing node1 = (TDecreasing) pop();
        ASimpleForControl node = new ASimpleForControl(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new32()
    {
        PStepBit node7 = (PStepBit) pop();
        PExpression node6 = (PExpression) pop();
        TTo node5 = (TTo) pop();
        PExpression node4 = (PExpression) pop();
        TAssign node3 = (TAssign) pop();
        PName node2 = (PName) pop();
        TDecreasing node1 = null;
        ASimpleForControl node = new ASimpleForControl(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new33()
    {
        PStepBit node7 = (PStepBit) pop();
        PExpression node6 = (PExpression) pop();
        TTo node5 = (TTo) pop();
        PExpression node4 = (PExpression) pop();
        TAssign node3 = (TAssign) pop();
        PName node2 = (PName) pop();
        TDecreasing node1 = (TDecreasing) pop();
        ASimpleForControl node = new ASimpleForControl(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new34()
    {
        PExpression node2 = (PExpression) pop();
        TStep node1 = (TStep) pop();
        AStepBit node = new AStepBit(node1, node2);
        return node;
    }

    Node new35()
    {
        TRBrace node3 = (TRBrace) pop();
        PStatements node2 = (PStatements) pop();
        TLBrace node1 = (TLBrace) pop();
        ABlock node = new ABlock(node1, node2, node3);
        return node;
    }

    Node new36()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PActualParamList node3 = (PActualParamList) pop();
        TLParenthese node2 = (TLParenthese) pop();
        PName node1 = (PName) pop();
        AFunctionApplication node = new AFunctionApplication(node1, node2, node3, node4);
        return node;
    }

    Node new37()
    {
        PExpression node3 = (PExpression) pop();
        TComma node2 = (TComma) pop();
        PActualParamList node1 = (PActualParamList) pop();
        AListActualParamList node = new AListActualParamList(node1, node2, node3);
        return node;
    }

    Node new38()
    {
        PExpression node1 = (PExpression) pop();
        AExpActualParamList node = new AExpActualParamList(node1);
        return node;
    }

    Node new39()
    {
        AEmptyActualParamList node = new AEmptyActualParamList();
        return node;
    }

    Node new40()
    {
        PMathExpression node7 = (PMathExpression) pop();
        TComma node6 = (TComma) pop();
        PMathExpression node5 = (PMathExpression) pop();
        TComma node4 = (TComma) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TComma node2 = (TComma) pop();
        PMathExpression node1 = (PMathExpression) pop();
        AFourNumbers node = new AFourNumbers(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new41()
    {
        PMathExpression node5 = (PMathExpression) pop();
        TComma node4 = (TComma) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TComma node2 = (TComma) pop();
        PFourNumbers node1 = (PFourNumbers) pop();
        ASixNumbers node = new ASixNumbers(node1, node2, node3, node4, node5);
        return node;
    }

    Node new42()
    {
        PMathExpression node5 = (PMathExpression) pop();
        TComma node4 = (TComma) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TComma node2 = (TComma) pop();
        PMathExpression node1 = (PMathExpression) pop();
        ARgb node = new ARgb(node1, node2, node3, node4, node5);
        return node;
    }

    Node new43()
    {
        TRBrace node3 = (TRBrace) pop();
        XPPossibleCase node2 = null;
        TLBrace node1 = (TLBrace) pop();
        ASwitchBlock node = new ASwitchBlock(node1, node2, node3);
        return node;
    }

    Node new44()
    {
        TRBrace node3 = (TRBrace) pop();
        XPPossibleCase node2 = (XPPossibleCase) pop();
        TLBrace node1 = (TLBrace) pop();
        ASwitchBlock node = new ASwitchBlock(node1, node2, node3);
        return node;
    }

    Node new45()
    {
        PPossibleCase node2 = (PPossibleCase) pop();
        XPPossibleCase node1 = (XPPossibleCase) pop();
        X1PPossibleCase node = new X1PPossibleCase(node1, node2);
        return node;
    }

    Node new46()
    {
        PPossibleCase node1 = (PPossibleCase) pop();
        X2PPossibleCase node = new X2PPossibleCase(node1);
        return node;
    }

    Node new47()
    {
        PBlock node2 = (PBlock) pop();
        PSwitchLabel node1 = (PSwitchLabel) pop();
        APossibleCase node = new APossibleCase(node1, node2);
        return node;
    }

    Node new48()
    {
        TColon node3 = (TColon) pop();
        PExpression node2 = (PExpression) pop();
        TCase node1 = (TCase) pop();
        ACaseSwitchLabel node = new ACaseSwitchLabel(node1, node2, node3);
        return node;
    }

    Node new49()
    {
        TColon node2 = (TColon) pop();
        TDefault node1 = (TDefault) pop();
        ADefaultSwitchLabel node = new ADefaultSwitchLabel(node1, node2);
        return node;
    }

    Node new50()
    {
        TRBrace node5 = (TRBrace) pop();
        XPDeclaration node4 = null;
        TLBrace node3 = (TLBrace) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TKlass node1 = (TKlass) pop();
        AClassDecDeclaration node = new AClassDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new51()
    {
        TRBrace node5 = (TRBrace) pop();
        XPDeclaration node4 = (XPDeclaration) pop();
        TLBrace node3 = (TLBrace) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TKlass node1 = (TKlass) pop();
        AClassDecDeclaration node = new AClassDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new52()
    {
        PDeclaration node2 = (PDeclaration) pop();
        XPDeclaration node1 = (XPDeclaration) pop();
        X1PDeclaration node = new X1PDeclaration(node1, node2);
        return node;
    }

    Node new53()
    {
        PDeclaration node1 = (PDeclaration) pop();
        X2PDeclaration node = new X2PDeclaration(node1);
        return node;
    }

    Node new54()
    {
        PBlock node7 = (PBlock) pop();
        TRParenthese node6 = (TRParenthese) pop();
        PFormalParamList node5 = null;
        TLParenthese node4 = (TLParenthese) pop();
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = null;
        PType node1 = (PType) pop();
        AFuncDecDeclaration node = new AFuncDecDeclaration(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new55()
    {
        PBlock node7 = (PBlock) pop();
        TRParenthese node6 = (TRParenthese) pop();
        PFormalParamList node5 = null;
        TLParenthese node4 = (TLParenthese) pop();
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = (XTBracketPair) pop();
        PType node1 = (PType) pop();
        AFuncDecDeclaration node = new AFuncDecDeclaration(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new56()
    {
        TBracketPair node2 = (TBracketPair) pop();
        XTBracketPair node1 = (XTBracketPair) pop();
        X1TBracketPair node = new X1TBracketPair(node1, node2);
        return node;
    }

    Node new57()
    {
        TBracketPair node1 = (TBracketPair) pop();
        X2TBracketPair node = new X2TBracketPair(node1);
        return node;
    }

    Node new58()
    {
        PBlock node7 = (PBlock) pop();
        TRParenthese node6 = (TRParenthese) pop();
        PFormalParamList node5 = (PFormalParamList) pop();
        TLParenthese node4 = (TLParenthese) pop();
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = null;
        PType node1 = (PType) pop();
        AFuncDecDeclaration node = new AFuncDecDeclaration(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new59()
    {
        PBlock node7 = (PBlock) pop();
        TRParenthese node6 = (TRParenthese) pop();
        PFormalParamList node5 = (PFormalParamList) pop();
        TLParenthese node4 = (TLParenthese) pop();
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = (XTBracketPair) pop();
        PType node1 = (PType) pop();
        AFuncDecDeclaration node = new AFuncDecDeclaration(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new60()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PInitialiser node4 = (PInitialiser) pop();
        TIdentifier node3 = (TIdentifier) pop();
        PType node2 = (PType) pop();
        TConst node1 = (TConst) pop();
        AConstDecDeclaration node = new AConstDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new61()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PInitialiser node4 = null;
        TIdentifier node3 = (TIdentifier) pop();
        PTypeParam node2 = null;
        PType node1 = (PType) pop();
        AVarDecDeclaration node = new AVarDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new62()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PInitialiser node4 = null;
        TIdentifier node3 = (TIdentifier) pop();
        PTypeParam node2 = (PTypeParam) pop();
        PType node1 = (PType) pop();
        AVarDecDeclaration node = new AVarDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new63()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PInitialiser node4 = (PInitialiser) pop();
        TIdentifier node3 = (TIdentifier) pop();
        PTypeParam node2 = null;
        PType node1 = (PType) pop();
        AVarDecDeclaration node = new AVarDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new64()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PInitialiser node4 = (PInitialiser) pop();
        TIdentifier node3 = (TIdentifier) pop();
        PTypeParam node2 = (PTypeParam) pop();
        PType node1 = (PType) pop();
        AVarDecDeclaration node = new AVarDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new65()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PArrayInitialiser node4 = null;
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = (XTBracketPair) pop();
        PType node1 = (PType) pop();
        AArrayDecDeclaration node = new AArrayDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new66()
    {
        TSemicolon node5 = (TSemicolon) pop();
        PArrayInitialiser node4 = (PArrayInitialiser) pop();
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = (XTBracketPair) pop();
        PType node1 = (PType) pop();
        AArrayDecDeclaration node = new AArrayDecDeclaration(node1, node2, node3, node4, node5);
        return node;
    }

    Node new67()
    {
        XPCommaTypeName node2 = null;
        PTypeName node1 = (PTypeName) pop();
        AFormalParamList node = new AFormalParamList(node1, node2);
        return node;
    }

    Node new68()
    {
        XPCommaTypeName node2 = (XPCommaTypeName) pop();
        PTypeName node1 = (PTypeName) pop();
        AFormalParamList node = new AFormalParamList(node1, node2);
        return node;
    }

    Node new69()
    {
        PCommaTypeName node2 = (PCommaTypeName) pop();
        XPCommaTypeName node1 = (XPCommaTypeName) pop();
        X1PCommaTypeName node = new X1PCommaTypeName(node1, node2);
        return node;
    }

    Node new70()
    {
        PCommaTypeName node1 = (PCommaTypeName) pop();
        X2PCommaTypeName node = new X2PCommaTypeName(node1);
        return node;
    }

    Node new71()
    {
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = null;
        PType node1 = (PType) pop();
        ATypeName node = new ATypeName(node1, node2, node3);
        return node;
    }

    Node new72()
    {
        TIdentifier node3 = (TIdentifier) pop();
        XTBracketPair node2 = (XTBracketPair) pop();
        PType node1 = (PType) pop();
        ATypeName node = new ATypeName(node1, node2, node3);
        return node;
    }

    Node new73()
    {
        PTypeName node2 = (PTypeName) pop();
        TComma node1 = (TComma) pop();
        ACommaTypeName node = new ACommaTypeName(node1, node2);
        return node;
    }

    Node new74()
    {
        PExpression node2 = (PExpression) pop();
        TAssign node1 = (TAssign) pop();
        AInitialiser node = new AInitialiser(node1, node2);
        return node;
    }

    Node new75()
    {
        PArrayInit node2 = (PArrayInit) pop();
        TAssign node1 = (TAssign) pop();
        AStaticArrayInitialiser node = new AStaticArrayInitialiser(node1, node2);
        return node;
    }

    Node new76()
    {
        PArrayAllocate node2 = (PArrayAllocate) pop();
        TAssign node1 = (TAssign) pop();
        ADynamicArrayInitialiser node = new ADynamicArrayInitialiser(node1, node2);
        return node;
    }

    Node new77()
    {
        TRBrace node3 = (TRBrace) pop();
        PInitList node2 = (PInitList) pop();
        TLBrace node1 = (TLBrace) pop();
        AArrayInit node = new AArrayInit(node1, node2, node3);
        return node;
    }

    Node new78()
    {
        XPCommaExp node2 = null;
        PExpression node1 = (PExpression) pop();
        AScalarInitList node = new AScalarInitList(node1, node2);
        return node;
    }

    Node new79()
    {
        XPCommaExp node2 = (XPCommaExp) pop();
        PExpression node1 = (PExpression) pop();
        AScalarInitList node = new AScalarInitList(node1, node2);
        return node;
    }

    Node new80()
    {
        PCommaExp node2 = (PCommaExp) pop();
        XPCommaExp node1 = (XPCommaExp) pop();
        X1PCommaExp node = new X1PCommaExp(node1, node2);
        return node;
    }

    Node new81()
    {
        PCommaExp node1 = (PCommaExp) pop();
        X2PCommaExp node = new X2PCommaExp(node1);
        return node;
    }

    Node new82()
    {
        XPCommaArrayInit node2 = null;
        PArrayInit node1 = (PArrayInit) pop();
        AArrayInitList node = new AArrayInitList(node1, node2);
        return node;
    }

    Node new83()
    {
        XPCommaArrayInit node2 = (XPCommaArrayInit) pop();
        PArrayInit node1 = (PArrayInit) pop();
        AArrayInitList node = new AArrayInitList(node1, node2);
        return node;
    }

    Node new84()
    {
        PCommaArrayInit node2 = (PCommaArrayInit) pop();
        XPCommaArrayInit node1 = (XPCommaArrayInit) pop();
        X1PCommaArrayInit node = new X1PCommaArrayInit(node1, node2);
        return node;
    }

    Node new85()
    {
        PCommaArrayInit node1 = (PCommaArrayInit) pop();
        X2PCommaArrayInit node = new X2PCommaArrayInit(node1);
        return node;
    }

    Node new86()
    {
        PExpression node2 = (PExpression) pop();
        TComma node1 = (TComma) pop();
        ACommaExp node = new ACommaExp(node1, node2);
        return node;
    }

    Node new87()
    {
        PArrayInit node2 = (PArrayInit) pop();
        TComma node1 = (TComma) pop();
        ACommaArrayInit node = new ACommaArrayInit(node1, node2);
        return node;
    }

    Node new88()
    {
        PExpression node2 = (PExpression) pop();
        TColon node1 = (TColon) pop();
        AColonString node = new AColonString(node1, node2);
        return node;
    }

    Node new89()
    {
        TTrue node1 = (TTrue) pop();
        ATrueBooleanliteral node = new ATrueBooleanliteral(node1);
        return node;
    }

    Node new90()
    {
        TFalse node1 = (TFalse) pop();
        AFalseBooleanliteral node = new AFalseBooleanliteral(node1);
        return node;
    }

    Node new91()
    {
        PBasicType node1 = (PBasicType) pop();
        ABasicTypeType node = new ABasicTypeType(node1);
        return node;
    }

    Node new92()
    {
        PReferenceType node1 = (PReferenceType) pop();
        AReferenceTypeType node = new AReferenceTypeType(node1);
        return node;
    }

    Node new93()
    {
        TChar node1 = (TChar) pop();
        ACharBasicType node = new ACharBasicType(node1);
        return node;
    }

    Node new94()
    {
        TInt node1 = (TInt) pop();
        AIntBasicType node = new AIntBasicType(node1);
        return node;
    }

    Node new95()
    {
        TReal node1 = (TReal) pop();
        ARealBasicType node = new ARealBasicType(node1);
        return node;
    }

    Node new96()
    {
        TString node1 = (TString) pop();
        AStringBasicType node = new AStringBasicType(node1);
        return node;
    }

    Node new97()
    {
        TBoolean node1 = (TBoolean) pop();
        ABooleanBasicType node = new ABooleanBasicType(node1);
        return node;
    }

    Node new98()
    {
        TVoid node1 = (TVoid) pop();
        AVoidBasicType node = new AVoidBasicType(node1);
        return node;
    }

    Node new99()
    {
        PClassType node1 = (PClassType) pop();
        AClassTypeReferenceType node = new AClassTypeReferenceType(node1);
        return node;
    }

    Node new100()
    {
        TIdentifier node1 = (TIdentifier) pop();
        AClassType node = new AClassType(node1);
        return node;
    }

    Node new101()
    {
        TGreater node3 = (TGreater) pop();
        PTypeParamList node2 = (PTypeParamList) pop();
        TLess node1 = (TLess) pop();
        ATypeParam node = new ATypeParam(node1, node2, node3);
        return node;
    }

    Node new102()
    {
        XPCommaType node2 = null;
        PType node1 = (PType) pop();
        ATypeParamList node = new ATypeParamList(node1, node2);
        return node;
    }

    Node new103()
    {
        XPCommaType node2 = (XPCommaType) pop();
        PType node1 = (PType) pop();
        ATypeParamList node = new ATypeParamList(node1, node2);
        return node;
    }

    Node new104()
    {
        PCommaType node2 = (PCommaType) pop();
        XPCommaType node1 = (XPCommaType) pop();
        X1PCommaType node = new X1PCommaType(node1, node2);
        return node;
    }

    Node new105()
    {
        PCommaType node1 = (PCommaType) pop();
        X2PCommaType node = new X2PCommaType(node1);
        return node;
    }

    Node new106()
    {
        PType node2 = (PType) pop();
        TComma node1 = (TComma) pop();
        ACommaType node = new ACommaType(node1, node2);
        return node;
    }

    Node new107()
    {
        PBoolExpression node1 = (PBoolExpression) pop();
        ABoolexpExpression node = new ABoolexpExpression(node1);
        return node;
    }

    Node new108()
    {
        PArrayAllocate node1 = (PArrayAllocate) pop();
        AArrayIntExpression node = new AArrayIntExpression(node1);
        return node;
    }

    Node new109()
    {
        XTBracketPair node4 = null;
        XPArrayAccess node3 = (XPArrayAccess) pop();
        PType node2 = (PType) pop();
        TNew node1 = (TNew) pop();
        AArrayAllocate node = new AArrayAllocate(node1, node2, node3, node4);
        return node;
    }

    Node new110()
    {
        PArrayAccess node2 = (PArrayAccess) pop();
        XPArrayAccess node1 = (XPArrayAccess) pop();
        X1PArrayAccess node = new X1PArrayAccess(node1, node2);
        return node;
    }

    Node new111()
    {
        PArrayAccess node1 = (PArrayAccess) pop();
        X2PArrayAccess node = new X2PArrayAccess(node1);
        return node;
    }

    Node new112()
    {
        XTBracketPair node4 = (XTBracketPair) pop();
        XPArrayAccess node3 = (XPArrayAccess) pop();
        PType node2 = (PType) pop();
        TNew node1 = (TNew) pop();
        AArrayAllocate node = new AArrayAllocate(node1, node2, node3, node4);
        return node;
    }

    Node new113()
    {
        PTerm node1 = (PTerm) pop();
        ATermMathExpression node = new ATermMathExpression(node1);
        return node;
    }

    Node new114()
    {
        PTerm node3 = (PTerm) pop();
        TPlus node2 = (TPlus) pop();
        PMathExpression node1 = (PMathExpression) pop();
        APlusMathExpression node = new APlusMathExpression(node1, node2, node3);
        return node;
    }

    Node new115()
    {
        PTerm node3 = (PTerm) pop();
        TMinus node2 = (TMinus) pop();
        PMathExpression node1 = (PMathExpression) pop();
        AMinusMathExpression node = new AMinusMathExpression(node1, node2, node3);
        return node;
    }

    Node new116()
    {
        PUnaryExp node1 = (PUnaryExp) pop();
        AUnaryTerm node = new AUnaryTerm(node1);
        return node;
    }

    Node new117()
    {
        PUnaryExp node3 = (PUnaryExp) pop();
        TTimes node2 = (TTimes) pop();
        PTerm node1 = (PTerm) pop();
        AMultTerm node = new AMultTerm(node1, node2, node3);
        return node;
    }

    Node new118()
    {
        PUnaryExp node3 = (PUnaryExp) pop();
        TDivide node2 = (TDivide) pop();
        PTerm node1 = (PTerm) pop();
        ADivTerm node = new ADivTerm(node1, node2, node3);
        return node;
    }

    Node new119()
    {
        PUnaryExp node3 = (PUnaryExp) pop();
        TMod node2 = (TMod) pop();
        PTerm node1 = (PTerm) pop();
        AModTerm node = new AModTerm(node1, node2, node3);
        return node;
    }

    Node new120()
    {
        PUnaryExp node3 = (PUnaryExp) pop();
        TPower node2 = (TPower) pop();
        PTerm node1 = (PTerm) pop();
        APowerTerm node = new APowerTerm(node1, node2, node3);
        return node;
    }

    Node new121()
    {
        PPreincr node1 = (PPreincr) pop();
        APreincrUnaryExp node = new APreincrUnaryExp(node1);
        return node;
    }

    Node new122()
    {
        PPredecr node1 = (PPredecr) pop();
        APredecrUnaryExp node = new APredecrUnaryExp(node1);
        return node;
    }

    Node new123()
    {
        PUnaryExp node2 = (PUnaryExp) pop();
        TMinus node1 = (TMinus) pop();
        AMinusUnaryExp node = new AMinusUnaryExp(node1, node2);
        return node;
    }

    Node new124()
    {
        PUnaryExp node2 = (PUnaryExp) pop();
        TPlus node1 = (TPlus) pop();
        APlusUnaryExp node = new APlusUnaryExp(node1, node2);
        return node;
    }

    Node new125()
    {
        PUnaryExp node2 = (PUnaryExp) pop();
        TNot node1 = (TNot) pop();
        ANegateUnaryExp node = new ANegateUnaryExp(node1, node2);
        return node;
    }

    Node new126()
    {
        PPostfixExp node1 = (PPostfixExp) pop();
        APostfixExpUnaryExp node = new APostfixExpUnaryExp(node1);
        return node;
    }

    Node new127()
    {
        PFactor node1 = (PFactor) pop();
        AFactorPostfixExp node = new AFactorPostfixExp(node1);
        return node;
    }

    Node new128()
    {
        PPostincr node1 = (PPostincr) pop();
        APostincrPostfixExp node = new APostincrPostfixExp(node1);
        return node;
    }

    Node new129()
    {
        PPostdecr node1 = (PPostdecr) pop();
        APostdecrPostfixExp node = new APostdecrPostfixExp(node1);
        return node;
    }

    Node new130()
    {
        TMinusminus node2 = (TMinusminus) pop();
        PPostfixExp node1 = (PPostfixExp) pop();
        APostdecr node = new APostdecr(node1, node2);
        return node;
    }

    Node new131()
    {
        TPlusplus node2 = (TPlusplus) pop();
        PPostfixExp node1 = (PPostfixExp) pop();
        APostincr node = new APostincr(node1, node2);
        return node;
    }

    Node new132()
    {
        PPostfixExp node2 = (PPostfixExp) pop();
        TMinusminus node1 = (TMinusminus) pop();
        APredecr node = new APredecr(node1, node2);
        return node;
    }

    Node new133()
    {
        PPostfixExp node2 = (PPostfixExp) pop();
        TPlusplus node1 = (TPlusplus) pop();
        APreincr node = new APreincr(node1, node2);
        return node;
    }

    Node new134()
    {
        TNull node1 = (TNull) pop();
        ANullFactor node = new ANullFactor(node1);
        return node;
    }

    Node new135()
    {
        PFieldAccess node1 = (PFieldAccess) pop();
        AFieldaccessFactor node = new AFieldaccessFactor(node1);
        return node;
    }

    Node new136()
    {
        PFunctionApplication node1 = (PFunctionApplication) pop();
        AFunctionFactor node = new AFunctionFactor(node1);
        return node;
    }

    Node new137()
    {
        PNumber node1 = (PNumber) pop();
        ANumberFactor node = new ANumberFactor(node1);
        return node;
    }

    Node new138()
    {
        TStringliteral node1 = (TStringliteral) pop();
        AStringliteralFactor node = new AStringliteralFactor(node1);
        return node;
    }

    Node new139()
    {
        TCharliteral node1 = (TCharliteral) pop();
        ACharliteralFactor node = new ACharliteralFactor(node1);
        return node;
    }

    Node new140()
    {
        PBooleanliteral node1 = (PBooleanliteral) pop();
        ABoolliteralFactor node = new ABoolliteralFactor(node1);
        return node;
    }

    Node new141()
    {
        TReadint node1 = (TReadint) pop();
        AReadintFactor node = new AReadintFactor(node1);
        return node;
    }

    Node new142()
    {
        TReadreal node1 = (TReadreal) pop();
        AReadrealFactor node = new AReadrealFactor(node1);
        return node;
    }

    Node new143()
    {
        TReadstring node1 = (TReadstring) pop();
        AReadstringFactor node = new AReadstringFactor(node1);
        return node;
    }

    Node new144()
    {
        TReadchar node1 = (TReadchar) pop();
        AReadcharFactor node = new AReadcharFactor(node1);
        return node;
    }

    Node new145()
    {
        TRead node1 = (TRead) pop();
        AReadFactor node = new AReadFactor(node1);
        return node;
    }

    Node new146()
    {
        TEndoffile node1 = (TEndoffile) pop();
        AEndoffileFactor node = new AEndoffileFactor(node1);
        return node;
    }

    Node new147()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TSin node1 = (TSin) pop();
        ASinFactor node = new ASinFactor(node1, node2, node3, node4);
        return node;
    }

    Node new148()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TCos node1 = (TCos) pop();
        ACosFactor node = new ACosFactor(node1, node2, node3, node4);
        return node;
    }

    Node new149()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TTan node1 = (TTan) pop();
        ATanFactor node = new ATanFactor(node1, node2, node3, node4);
        return node;
    }

    Node new150()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TAsin node1 = (TAsin) pop();
        AAsinFactor node = new AAsinFactor(node1, node2, node3, node4);
        return node;
    }

    Node new151()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TAcos node1 = (TAcos) pop();
        AAcosFactor node = new AAcosFactor(node1, node2, node3, node4);
        return node;
    }

    Node new152()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TAtan node1 = (TAtan) pop();
        AAtanFactor node = new AAtanFactor(node1, node2, node3, node4);
        return node;
    }

    Node new153()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TSqrt node1 = (TSqrt) pop();
        ASqrtFactor node = new ASqrtFactor(node1, node2, node3, node4);
        return node;
    }

    Node new154()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TLog node1 = (TLog) pop();
        ALogFactor node = new ALogFactor(node1, node2, node3, node4);
        return node;
    }

    Node new155()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TExp node1 = (TExp) pop();
        AExpFactor node = new AExpFactor(node1, node2, node3, node4);
        return node;
    }

    Node new156()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TAbs node1 = (TAbs) pop();
        AAbsFactor node = new AAbsFactor(node1, node2, node3, node4);
        return node;
    }

    Node new157()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TFloor node1 = (TFloor) pop();
        AFloorFactor node = new AFloorFactor(node1, node2, node3, node4);
        return node;
    }

    Node new158()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TCeil node1 = (TCeil) pop();
        ACeilFactor node = new ACeilFactor(node1, node2, node3, node4);
        return node;
    }

    Node new159()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PMathExpression node3 = (PMathExpression) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TRound node1 = (TRound) pop();
        ARoundFactor node = new ARoundFactor(node1, node2, node3, node4);
        return node;
    }

    Node new160()
    {
        TRParenthese node3 = (TRParenthese) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TRandom node1 = (TRandom) pop();
        ARandomFactor node = new ARandomFactor(node1, node2, node3);
        return node;
    }

    Node new161()
    {
        TRParenthese node3 = (TRParenthese) pop();
        PBoolExpression node2 = (PBoolExpression) pop();
        TLParenthese node1 = (TLParenthese) pop();
        AExpressionFactor node = new AExpressionFactor(node1, node2, node3);
        return node;
    }

    Node new162()
    {
        TIntnumber node1 = (TIntnumber) pop();
        AINumber node = new AINumber(node1);
        return node;
    }

    Node new163()
    {
        TFpnumber node1 = (TFpnumber) pop();
        AFNumber node = new AFNumber(node1);
        return node;
    }

    Node new164()
    {
        PBoolTerm node1 = (PBoolTerm) pop();
        ATermBoolExpression node = new ATermBoolExpression(node1);
        return node;
    }

    Node new165()
    {
        PBoolTerm node3 = (PBoolTerm) pop();
        TOr node2 = (TOr) pop();
        PBoolExpression node1 = (PBoolExpression) pop();
        AOrBoolExpression node = new AOrBoolExpression(node1, node2, node3);
        return node;
    }

    Node new166()
    {
        PBoolTerm node3 = (PBoolTerm) pop();
        TXor node2 = (TXor) pop();
        PBoolExpression node1 = (PBoolExpression) pop();
        AXorBoolExpression node = new AXorBoolExpression(node1, node2, node3);
        return node;
    }

    Node new167()
    {
        PEquality node1 = (PEquality) pop();
        AEqualityBoolTerm node = new AEqualityBoolTerm(node1);
        return node;
    }

    Node new168()
    {
        PEquality node3 = (PEquality) pop();
        TAnd node2 = (TAnd) pop();
        PBoolTerm node1 = (PBoolTerm) pop();
        AAndBoolTerm node = new AAndBoolTerm(node1, node2, node3);
        return node;
    }

    Node new169()
    {
        PRelational node1 = (PRelational) pop();
        ARelationalEquality node = new ARelationalEquality(node1);
        return node;
    }

    Node new170()
    {
        PRelational node3 = (PRelational) pop();
        TEqual node2 = (TEqual) pop();
        PEquality node1 = (PEquality) pop();
        AEqEquality node = new AEqEquality(node1, node2, node3);
        return node;
    }

    Node new171()
    {
        PRelational node3 = (PRelational) pop();
        TNotequal node2 = (TNotequal) pop();
        PEquality node1 = (PEquality) pop();
        ANeqEquality node = new ANeqEquality(node1, node2, node3);
        return node;
    }

    Node new172()
    {
        PMathExpression node1 = (PMathExpression) pop();
        AMathRelational node = new AMathRelational(node1);
        return node;
    }

    Node new173()
    {
        PMathExpression node3 = (PMathExpression) pop();
        TLess node2 = (TLess) pop();
        PRelational node1 = (PRelational) pop();
        ALtRelational node = new ALtRelational(node1, node2, node3);
        return node;
    }

    Node new174()
    {
        PMathExpression node3 = (PMathExpression) pop();
        TGreater node2 = (TGreater) pop();
        PRelational node1 = (PRelational) pop();
        AGtRelational node = new AGtRelational(node1, node2, node3);
        return node;
    }

    Node new175()
    {
        PMathExpression node3 = (PMathExpression) pop();
        TLessequal node2 = (TLessequal) pop();
        PRelational node1 = (PRelational) pop();
        ALteqRelational node = new ALteqRelational(node1, node2, node3);
        return node;
    }

    Node new176()
    {
        PMathExpression node3 = (PMathExpression) pop();
        TGreaterequal node2 = (TGreaterequal) pop();
        PRelational node1 = (PRelational) pop();
        AGteqRelational node = new AGteqRelational(node1, node2, node3);
        return node;
    }

    Node new177()
    {
        XPArrayAccess node2 = (XPArrayAccess) pop();
        PName node1 = (PName) pop();
        AArrayFieldAccess node = new AArrayFieldAccess(node1, node2);
        return node;
    }

    Node new178()
    {
        PName node1 = (PName) pop();
        AScalarFieldAccess node = new AScalarFieldAccess(node1);
        return node;
    }

    Node new179()
    {
        PSimpleName node1 = (PSimpleName) pop();
        ASimpleNameName node = new ASimpleNameName(node1);
        return node;
    }

    Node new180()
    {
        PQualifiedName node1 = (PQualifiedName) pop();
        AQualifiedNameName node = new AQualifiedNameName(node1);
        return node;
    }

    Node new181()
    {
        TIdentifier node1 = (TIdentifier) pop();
        ASimpleName node = new ASimpleName(node1);
        return node;
    }

    Node new182()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TDot node2 = (TDot) pop();
        PFieldAccess node1 = (PFieldAccess) pop();
        AQualifiedName node = new AQualifiedName(node1, node2, node3);
        return node;
    }

    Node new183()
    {
        TRBracket node3 = (TRBracket) pop();
        PMathExpression node2 = (PMathExpression) pop();
        TLBracket node1 = (TLBracket) pop();
        AArrayAccess node = new AArrayAccess(node1, node2, node3);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {12, SHIFT, 12}, {13, SHIFT, 13}, {14, SHIFT, 14}, {16, SHIFT, 15}, {18, SHIFT, 16}, {22, SHIFT, 17}, {23, SHIFT, 18}, {52, SHIFT, 19}, {53, SHIFT, 20}, {54, SHIFT, 21}, {55, SHIFT, 22}, {56, SHIFT, 23}, {57, SHIFT, 24}, {58, SHIFT, 25}, {59, SHIFT, 26}, {60, SHIFT, 27}, {61, SHIFT, 28}, },
			{{-1, REDUCE, 97}, },
			{{-1, REDUCE, 93}, },
			{{-1, REDUCE, 94}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 96}, },
			{{-1, REDUCE, 98}, },
			{{-1, ERROR, 7}, {61, SHIFT, 41}, },
			{{-1, ERROR, 8}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, },
			{{-1, ERROR, 9}, {64, SHIFT, 44}, },
			{{-1, ERROR, 10}, {64, SHIFT, 45}, },
			{{-1, ERROR, 11}, {64, SHIFT, 46}, },
			{{-1, ERROR, 12}, {64, SHIFT, 47}, },
			{{-1, ERROR, 13}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {71, SHIFT, 77}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 14}, {64, SHIFT, 103}, },
			{{-1, ERROR, 15}, {71, SHIFT, 104}, },
			{{-1, ERROR, 16}, {21, SHIFT, 105}, {61, SHIFT, 73}, {64, SHIFT, 106}, },
			{{-1, ERROR, 17}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 18}, {64, SHIFT, 111}, },
			{{-1, ERROR, 19}, {64, SHIFT, 112}, },
			{{-1, ERROR, 20}, {64, SHIFT, 113}, },
			{{-1, ERROR, 21}, {64, SHIFT, 114}, },
			{{-1, ERROR, 22}, {64, SHIFT, 115}, },
			{{-1, ERROR, 23}, {64, SHIFT, 116}, },
			{{-1, ERROR, 24}, {71, SHIFT, 117}, },
			{{-1, ERROR, 25}, {64, SHIFT, 118}, },
			{{-1, ERROR, 26}, {64, SHIFT, 119}, },
			{{-1, ERROR, 27}, {64, SHIFT, 120}, },
			{{-1, REDUCE, 181}, {61, REDUCE, 100}, {70, REDUCE, 100}, {83, REDUCE, 100}, },
			{{-1, ERROR, 29}, {92, ACCEPT, -1}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {12, SHIFT, 12}, {13, SHIFT, 13}, {14, SHIFT, 14}, {16, SHIFT, 15}, {18, SHIFT, 16}, {22, SHIFT, 17}, {23, SHIFT, 18}, {52, SHIFT, 19}, {53, SHIFT, 20}, {54, SHIFT, 21}, {55, SHIFT, 22}, {56, SHIFT, 23}, {57, SHIFT, 24}, {58, SHIFT, 25}, {59, SHIFT, 26}, {60, SHIFT, 27}, {61, SHIFT, 28}, },
			{{-1, ERROR, 31}, {71, SHIFT, 122}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 33}, {61, SHIFT, 123}, {70, SHIFT, 124}, {83, SHIFT, 125}, },
			{{-1, REDUCE, 91}, },
			{{-1, REDUCE, 92}, },
			{{-1, REDUCE, 99}, },
			{{-1, ERROR, 37}, {74, SHIFT, 128}, {89, SHIFT, 129}, },
			{{-1, REDUCE, 178}, {64, SHIFT, 130}, {68, SHIFT, 131}, },
			{{-1, REDUCE, 179}, },
			{{-1, REDUCE, 180}, },
			{{-1, ERROR, 41}, {66, SHIFT, 134}, },
			{{-1, REDUCE, 100}, },
			{{-1, ERROR, 43}, {61, SHIFT, 135}, },
			{{-1, ERROR, 44}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 45}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 46}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 47}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 48}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, },
			{{-1, REDUCE, 89}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 134}, },
			{{-1, ERROR, 52}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 53}, {64, SHIFT, 142}, },
			{{-1, ERROR, 54}, {64, SHIFT, 143}, },
			{{-1, ERROR, 55}, {64, SHIFT, 144}, },
			{{-1, ERROR, 56}, {64, SHIFT, 145}, },
			{{-1, ERROR, 57}, {64, SHIFT, 146}, },
			{{-1, ERROR, 58}, {64, SHIFT, 147}, },
			{{-1, ERROR, 59}, {64, SHIFT, 148}, },
			{{-1, ERROR, 60}, {64, SHIFT, 149}, },
			{{-1, ERROR, 61}, {64, SHIFT, 150}, },
			{{-1, ERROR, 62}, {64, SHIFT, 151}, },
			{{-1, ERROR, 63}, {64, SHIFT, 152}, },
			{{-1, ERROR, 64}, {64, SHIFT, 153}, },
			{{-1, ERROR, 65}, {64, SHIFT, 154}, },
			{{-1, ERROR, 66}, {64, SHIFT, 155}, },
			{{-1, REDUCE, 145}, },
			{{-1, REDUCE, 141}, },
			{{-1, REDUCE, 142}, },
			{{-1, REDUCE, 143}, },
			{{-1, REDUCE, 144}, },
			{{-1, REDUCE, 146}, },
			{{-1, REDUCE, 181}, },
			{{-1, REDUCE, 138}, },
			{{-1, REDUCE, 139}, },
			{{-1, ERROR, 76}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 78}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 79}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 80}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 81}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 162}, },
			{{-1, REDUCE, 163}, },
			{{-1, REDUCE, 136}, },
			{{-1, REDUCE, 140}, },
			{{-1, ERROR, 86}, {71, SHIFT, 161}, },
			{{-1, REDUCE, 108}, },
			{{-1, REDUCE, 172}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 113}, {79, SHIFT, 164}, {80, SHIFT, 165}, {81, SHIFT, 166}, {82, SHIFT, 167}, },
			{{-1, REDUCE, 116}, },
			{{-1, REDUCE, 126}, {76, SHIFT, 168}, {78, SHIFT, 169}, },
			{{-1, REDUCE, 129}, },
			{{-1, REDUCE, 128}, },
			{{-1, REDUCE, 122}, },
			{{-1, REDUCE, 121}, },
			{{-1, REDUCE, 127}, },
			{{-1, REDUCE, 137}, },
			{{-1, REDUCE, 107}, {29, SHIFT, 170}, {30, SHIFT, 171}, },
			{{-1, REDUCE, 164}, {28, SHIFT, 172}, },
			{{-1, REDUCE, 167}, {87, SHIFT, 173}, {88, SHIFT, 174}, },
			{{-1, REDUCE, 169}, {83, SHIFT, 175}, {84, SHIFT, 176}, {85, SHIFT, 177}, {86, SHIFT, 178}, },
			{{-1, REDUCE, 135}, {74, SHIFT, 128}, },
			{{-1, ERROR, 103}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 14}, },
			{{-1, ERROR, 105}, {61, SHIFT, 73}, },
			{{-1, ERROR, 106}, {61, SHIFT, 73}, },
			{{-1, ERROR, 107}, {66, SHIFT, 182}, },
			{{-1, ERROR, 108}, {74, SHIFT, 128}, },
			{{-1, REDUCE, 178}, {68, SHIFT, 131}, {89, SHIFT, 184}, },
			{{-1, ERROR, 110}, {29, SHIFT, 170}, {30, SHIFT, 171}, {71, SHIFT, 185}, {72, SHIFT, 186}, },
			{{-1, ERROR, 111}, {61, SHIFT, 73}, },
			{{-1, ERROR, 112}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 113}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 114}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 115}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 116}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 118}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 119}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 120}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 123}, {64, SHIFT, 200}, {71, SHIFT, 201}, {89, SHIFT, 202}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 125}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, },
			{{-1, ERROR, 126}, {61, SHIFT, 206}, },
			{{-1, ERROR, 127}, {61, SHIFT, 207}, {70, SHIFT, 208}, },
			{{-1, ERROR, 128}, {61, SHIFT, 209}, },
			{{-1, ERROR, 129}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 39}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 131}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 111}, },
			{{-1, REDUCE, 177}, {68, SHIFT, 131}, },
			{{-1, ERROR, 134}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {61, SHIFT, 42}, {67, SHIFT, 215}, },
			{{-1, ERROR, 135}, {89, SHIFT, 202}, },
			{{-1, ERROR, 136}, {65, SHIFT, 219}, },
			{{-1, ERROR, 137}, {65, SHIFT, 220}, },
			{{-1, ERROR, 138}, {29, SHIFT, 170}, {30, SHIFT, 171}, {65, SHIFT, 221}, },
			{{-1, ERROR, 139}, {29, SHIFT, 170}, {30, SHIFT, 171}, {65, SHIFT, 222}, },
			{{-1, ERROR, 140}, {68, SHIFT, 131}, },
			{{-1, REDUCE, 125}, },
			{{-1, ERROR, 142}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 143}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 144}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 145}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 146}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 147}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 148}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 149}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 150}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 151}, {65, SHIFT, 233}, },
			{{-1, ERROR, 152}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 153}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 154}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 155}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 156}, {29, SHIFT, 170}, {30, SHIFT, 171}, {65, SHIFT, 238}, },
			{{-1, REDUCE, 124}, },
			{{-1, REDUCE, 133}, {76, SHIFT, 168}, {78, SHIFT, 169}, },
			{{-1, REDUCE, 123}, },
			{{-1, REDUCE, 132}, {76, SHIFT, 168}, {78, SHIFT, 169}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 162}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 163}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 164}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 165}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 166}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 167}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 131}, },
			{{-1, REDUCE, 130}, },
			{{-1, ERROR, 170}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 171}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 172}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 173}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 174}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 175}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 176}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 177}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 178}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 179}, {65, SHIFT, 254}, },
			{{-1, REDUCE, 178}, {68, SHIFT, 131}, {89, SHIFT, 255}, },
			{{-1, REDUCE, 178}, {68, SHIFT, 131}, {89, SHIFT, 256}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {8, SHIFT, 9}, {9, SHIFT, 10}, {10, SHIFT, 11}, {12, SHIFT, 12}, {13, SHIFT, 13}, {14, SHIFT, 14}, {16, SHIFT, 15}, {18, SHIFT, 16}, {22, SHIFT, 17}, {23, SHIFT, 18}, {52, SHIFT, 19}, {53, SHIFT, 20}, {54, SHIFT, 21}, {55, SHIFT, 22}, {56, SHIFT, 23}, {57, SHIFT, 24}, {58, SHIFT, 25}, {59, SHIFT, 26}, {60, SHIFT, 27}, {61, SHIFT, 28}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 184}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 186}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 187}, {71, SHIFT, 260}, },
			{{-1, REDUCE, 178}, {68, SHIFT, 131}, {73, SHIFT, 261}, },
			{{-1, ERROR, 189}, {65, SHIFT, 262}, },
			{{-1, ERROR, 190}, {73, SHIFT, 263}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 191}, {73, SHIFT, 264}, },
			{{-1, ERROR, 192}, {65, SHIFT, 265}, },
			{{-1, ERROR, 193}, {65, SHIFT, 266}, },
			{{-1, ERROR, 194}, {65, SHIFT, 267}, },
			{{-1, ERROR, 195}, {73, SHIFT, 268}, },
			{{-1, ERROR, 196}, {65, SHIFT, 269}, },
			{{-1, ERROR, 197}, {73, SHIFT, 270}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 198}, {65, SHIFT, 271}, },
			{{-1, ERROR, 199}, {29, SHIFT, 170}, {30, SHIFT, 171}, {65, SHIFT, 272}, },
			{{-1, ERROR, 200}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, {65, SHIFT, 273}, },
			{{-1, REDUCE, 61}, },
			{{-1, ERROR, 202}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 203}, {71, SHIFT, 278}, },
			{{-1, REDUCE, 102}, {73, SHIFT, 279}, },
			{{-1, ERROR, 205}, {85, SHIFT, 282}, },
			{{-1, ERROR, 206}, {71, SHIFT, 283}, {89, SHIFT, 202}, },
			{{-1, ERROR, 207}, {64, SHIFT, 285}, {71, SHIFT, 286}, {89, SHIFT, 287}, },
			{{-1, REDUCE, 56}, },
			{{-1, REDUCE, 182}, },
			{{-1, ERROR, 210}, {71, SHIFT, 289}, },
			{{-1, ERROR, 211}, {65, SHIFT, 290}, {73, SHIFT, 291}, },
			{{-1, REDUCE, 38}, },
			{{-1, ERROR, 213}, {69, SHIFT, 292}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 110}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 217}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {6, SHIFT, 7}, {7, SHIFT, 8}, {61, SHIFT, 42}, {67, SHIFT, 293}, },
			{{-1, ERROR, 218}, {71, SHIFT, 295}, },
			{{-1, ERROR, 219}, {71, SHIFT, 296}, },
			{{-1, ERROR, 220}, {71, SHIFT, 297}, },
			{{-1, ERROR, 221}, {66, SHIFT, 182}, },
			{{-1, ERROR, 222}, {66, SHIFT, 182}, },
			{{-1, REDUCE, 109}, {68, SHIFT, 131}, {70, SHIFT, 124}, },
			{{-1, ERROR, 224}, {65, SHIFT, 301}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 225}, {65, SHIFT, 302}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 226}, {65, SHIFT, 303}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 227}, {65, SHIFT, 304}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 228}, {65, SHIFT, 305}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 229}, {65, SHIFT, 306}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 230}, {65, SHIFT, 307}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 231}, {65, SHIFT, 308}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 232}, {65, SHIFT, 309}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 160}, },
			{{-1, ERROR, 234}, {65, SHIFT, 310}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 235}, {65, SHIFT, 311}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 236}, {65, SHIFT, 312}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 237}, {65, SHIFT, 313}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 161}, },
			{{-1, REDUCE, 114}, {79, SHIFT, 164}, {80, SHIFT, 165}, {81, SHIFT, 166}, {82, SHIFT, 167}, },
			{{-1, REDUCE, 115}, {79, SHIFT, 164}, {80, SHIFT, 165}, {81, SHIFT, 166}, {82, SHIFT, 167}, },
			{{-1, REDUCE, 117}, },
			{{-1, REDUCE, 118}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 119}, },
			{{-1, REDUCE, 165}, {28, SHIFT, 172}, },
			{{-1, REDUCE, 166}, {28, SHIFT, 172}, },
			{{-1, REDUCE, 168}, {87, SHIFT, 173}, {88, SHIFT, 174}, },
			{{-1, REDUCE, 170}, {83, SHIFT, 175}, {84, SHIFT, 176}, {85, SHIFT, 177}, {86, SHIFT, 178}, },
			{{-1, REDUCE, 171}, {83, SHIFT, 175}, {84, SHIFT, 176}, {85, SHIFT, 177}, {86, SHIFT, 178}, },
			{{-1, REDUCE, 173}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 175}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 174}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 176}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 254}, {66, SHIFT, 314}, },
			{{-1, ERROR, 255}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 256}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 257}, {67, SHIFT, 318}, },
			{{-1, ERROR, 258}, {19, SHIFT, 319}, },
			{{-1, REDUCE, 88}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 261}, {61, SHIFT, 73}, },
			{{-1, ERROR, 262}, {71, SHIFT, 321}, },
			{{-1, ERROR, 263}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 264}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 265}, {71, SHIFT, 324}, },
			{{-1, ERROR, 266}, {71, SHIFT, 325}, },
			{{-1, ERROR, 267}, {71, SHIFT, 326}, },
			{{-1, ERROR, 268}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 269}, {71, SHIFT, 328}, },
			{{-1, ERROR, 270}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 271}, {71, SHIFT, 330}, },
			{{-1, ERROR, 272}, {71, SHIFT, 331}, },
			{{-1, ERROR, 273}, {66, SHIFT, 182}, },
			{{-1, ERROR, 274}, {65, SHIFT, 333}, },
			{{-1, REDUCE, 67}, {73, SHIFT, 334}, },
			{{-1, ERROR, 276}, {61, SHIFT, 337}, {70, SHIFT, 124}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 279}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, },
			{{-1, REDUCE, 105}, },
			{{-1, REDUCE, 103}, {73, SHIFT, 279}, },
			{{-1, REDUCE, 101}, },
			{{-1, REDUCE, 62}, },
			{{-1, ERROR, 284}, {71, SHIFT, 341}, },
			{{-1, ERROR, 285}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, {65, SHIFT, 342}, },
			{{-1, REDUCE, 65}, },
			{{-1, ERROR, 287}, {24, SHIFT, 48}, {66, SHIFT, 344}, },
			{{-1, ERROR, 288}, {71, SHIFT, 347}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 291}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 183}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 52}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 5}, {11, SHIFT, 349}, {66, SHIFT, 182}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 112}, {70, SHIFT, 208}, },
			{{-1, REDUCE, 147}, },
			{{-1, REDUCE, 148}, },
			{{-1, REDUCE, 149}, },
			{{-1, REDUCE, 150}, },
			{{-1, REDUCE, 151}, },
			{{-1, REDUCE, 152}, },
			{{-1, REDUCE, 153}, },
			{{-1, REDUCE, 154}, },
			{{-1, REDUCE, 155}, },
			{{-1, REDUCE, 159}, },
			{{-1, REDUCE, 156}, },
			{{-1, REDUCE, 157}, },
			{{-1, REDUCE, 158}, },
			{{-1, ERROR, 314}, {15, SHIFT, 351}, {17, SHIFT, 352}, {67, SHIFT, 353}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 316}, {19, SHIFT, 357}, },
			{{-1, ERROR, 317}, {71, SHIFT, 358}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 319}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 178}, {65, SHIFT, 360}, {68, SHIFT, 131}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 322}, {73, SHIFT, 361}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 323}, {73, SHIFT, 362}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 327}, {73, SHIFT, 363}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 329}, {73, SHIFT, 364}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 27}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 54}, },
			{{-1, ERROR, 333}, {66, SHIFT, 182}, },
			{{-1, ERROR, 334}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 4}, {4, SHIFT, 5}, {5, SHIFT, 6}, {61, SHIFT, 42}, },
			{{-1, REDUCE, 70}, },
			{{-1, REDUCE, 68}, {73, SHIFT, 334}, },
			{{-1, REDUCE, 71}, },
			{{-1, ERROR, 338}, {61, SHIFT, 368}, {70, SHIFT, 208}, },
			{{-1, REDUCE, 106}, },
			{{-1, REDUCE, 104}, },
			{{-1, REDUCE, 64}, },
			{{-1, ERROR, 342}, {66, SHIFT, 182}, },
			{{-1, ERROR, 343}, {65, SHIFT, 370}, },
			{{-1, ERROR, 344}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {66, SHIFT, 344}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 76}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 37}, },
			{{-1, REDUCE, 6}, {66, SHIFT, 182}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 351}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 352}, {72, SHIFT, 376}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 355}, {66, SHIFT, 182}, },
			{{-1, ERROR, 356}, {15, SHIFT, 351}, {17, SHIFT, 352}, {67, SHIFT, 378}, },
			{{-1, ERROR, 357}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 358}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 30}, {20, SHIFT, 382}, },
			{{-1, ERROR, 360}, {71, SHIFT, 384}, },
			{{-1, ERROR, 361}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 362}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 363}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 364}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 58}, },
			{{-1, REDUCE, 73}, },
			{{-1, REDUCE, 69}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 55}, },
			{{-1, ERROR, 370}, {66, SHIFT, 182}, },
			{{-1, REDUCE, 82}, {73, SHIFT, 390}, },
			{{-1, ERROR, 372}, {67, SHIFT, 393}, },
			{{-1, REDUCE, 78}, {73, SHIFT, 394}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 375}, {72, SHIFT, 397}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 47}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 31}, {20, SHIFT, 382}, },
			{{-1, ERROR, 381}, {29, SHIFT, 170}, {30, SHIFT, 171}, {71, SHIFT, 399}, },
			{{-1, ERROR, 382}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 385}, {73, SHIFT, 401}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 41}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, ERROR, 387}, {65, SHIFT, 402}, },
			{{-1, REDUCE, 42}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 59}, },
			{{-1, ERROR, 390}, {66, SHIFT, 344}, },
			{{-1, REDUCE, 85}, },
			{{-1, REDUCE, 83}, {73, SHIFT, 390}, },
			{{-1, REDUCE, 77}, },
			{{-1, ERROR, 394}, {24, SHIFT, 48}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 81}, },
			{{-1, REDUCE, 79}, {73, SHIFT, 394}, },
			{{-1, REDUCE, 48}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 399}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 401}, {25, SHIFT, 49}, {26, SHIFT, 50}, {27, SHIFT, 51}, {31, SHIFT, 52}, {32, SHIFT, 53}, {33, SHIFT, 54}, {34, SHIFT, 55}, {35, SHIFT, 56}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {39, SHIFT, 60}, {40, SHIFT, 61}, {41, SHIFT, 62}, {42, SHIFT, 63}, {43, SHIFT, 64}, {44, SHIFT, 65}, {45, SHIFT, 66}, {46, SHIFT, 67}, {47, SHIFT, 68}, {48, SHIFT, 69}, {49, SHIFT, 70}, {50, SHIFT, 71}, {51, SHIFT, 72}, {61, SHIFT, 73}, {62, SHIFT, 74}, {63, SHIFT, 75}, {64, SHIFT, 76}, {75, SHIFT, 78}, {76, SHIFT, 79}, {77, SHIFT, 80}, {78, SHIFT, 81}, {90, SHIFT, 82}, {91, SHIFT, 83}, },
			{{-1, ERROR, 402}, {71, SHIFT, 409}, },
			{{-1, REDUCE, 87}, },
			{{-1, REDUCE, 84}, },
			{{-1, REDUCE, 86}, },
			{{-1, REDUCE, 80}, },
			{{-1, ERROR, 407}, {65, SHIFT, 410}, },
			{{-1, REDUCE, 40}, {75, SHIFT, 162}, {77, SHIFT, 163}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 29}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 29}, {30, 121}, {182, 257}, },
			{{-1, 30}, },
			{{-1, 107}, },
			{{-1, 383}, {380, 398}, },
			{{-1, 183}, {221, 298}, {222, 299}, {273, 332}, {298, 350}, {333, 365}, {342, 369}, {349, 374}, {355, 377}, {370, 389}, },
			{{-1, 84}, {0, 31}, {30, 31}, {182, 31}, },
			{{-1, 211}, },
			{{-1, 189}, {113, 191}, {114, 193}, {115, 194}, },
			{{-1, 192}, },
			{{-1, 196}, {119, 198}, },
			{{-1, 315}, },
			{{-1, 354}, {356, 379}, },
			{{-1, 355}, },
			{{-1, 32}, {134, 216}, {217, 294}, },
			{{-1, 274}, {285, 343}, },
			{{-1, 275}, {334, 366}, },
			{{-1, 335}, {336, 367}, },
			{{-1, 203}, {135, 218}, {206, 284}, },
			{{-1, 288}, },
			{{-1, 345}, {344, 371}, {390, 403}, },
			{{-1, 372}, },
			{{-1, 395}, {396, 406}, },
			{{-1, 391}, {392, 404}, },
			{{-1, 187}, },
			{{-1, 85}, },
			{{-1, 33}, {8, 43}, {48, 140}, {125, 204}, {200, 276}, {279, 339}, {285, 276}, {334, 276}, },
			{{-1, 34}, },
			{{-1, 35}, },
			{{-1, 36}, },
			{{-1, 126}, },
			{{-1, 205}, },
			{{-1, 280}, {281, 340}, },
			{{-1, 86}, {44, 136}, {45, 137}, {103, 179}, {116, 195}, {129, 210}, {130, 212}, {184, 258}, {186, 259}, {202, 277}, {255, 316}, {256, 317}, {268, 327}, {291, 348}, {319, 359}, {344, 373}, {351, 375}, {357, 380}, {363, 387}, {382, 400}, {394, 405}, },
			{{-1, 87}, {287, 346}, },
			{{-1, 88}, {112, 190}, {113, 190}, {114, 190}, {115, 190}, {118, 197}, {119, 197}, {131, 213}, {142, 224}, {143, 225}, {144, 226}, {145, 227}, {146, 228}, {147, 229}, {148, 230}, {149, 231}, {150, 232}, {152, 234}, {153, 235}, {154, 236}, {155, 237}, {175, 250}, {176, 251}, {177, 252}, {178, 253}, {263, 322}, {264, 323}, {270, 329}, {361, 385}, {362, 386}, {364, 388}, {401, 408}, },
			{{-1, 89}, {162, 239}, {163, 240}, },
			{{-1, 90}, {52, 141}, {78, 157}, {80, 159}, {164, 241}, {165, 242}, {166, 243}, {167, 244}, {399, 407}, },
			{{-1, 91}, {79, 158}, {81, 160}, },
			{{-1, 92}, },
			{{-1, 93}, },
			{{-1, 94}, },
			{{-1, 95}, },
			{{-1, 96}, },
			{{-1, 97}, },
			{{-1, 98}, {17, 110}, {46, 138}, {47, 139}, {76, 156}, {120, 199}, {358, 381}, },
			{{-1, 99}, {170, 245}, {171, 246}, },
			{{-1, 100}, {172, 247}, },
			{{-1, 101}, {173, 248}, {174, 249}, },
			{{-1, 102}, {0, 37}, {16, 108}, {30, 37}, {105, 108}, {106, 108}, {111, 108}, {182, 37}, {261, 108}, },
			{{-1, 38}, {16, 109}, {105, 180}, {106, 181}, {111, 188}, {261, 320}, },
			{{-1, 39}, },
			{{-1, 40}, },
			{{-1, 132}, {133, 214}, {223, 214}, },
			{{-1, 356}, },
			{{-1, 217}, },
			{{-1, 127}, {223, 300}, {276, 338}, },
			{{-1, 336}, },
			{{-1, 396}, },
			{{-1, 392}, },
			{{-1, 281}, },
			{{-1, 133}, {140, 223}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', 'print', 'println', 'if', 'while', 'return', 'switch', 'break', 'for', 'assert', 'arraycopy', 'drawBox', 'drawTriangle', 'drawEllipse', 'drawLine', 'drawString', 'clear()', 'setColour', 'setBGColour', 'fill', identifier, EOF",
			"expecting: identifier, '[', bracket pair, ',', '<', '>'",
			"expecting: identifier",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', identifier",
			"expecting: '('",
			"expecting: 'new', 'true', 'false', 'null', not, 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'sqrt', 'log', 'exp', 'random', 'round', 'abs', 'floor', 'ceil', 'read()', 'readInt()', 'readDouble()', 'readString()', 'readChar()', 'isEOF()', identifier, stringliteral, charliteral, '(', ';', '+', '++', '-', '--', intnumber, fpnumber",
			"expecting: ';'",
			"expecting: 'decreasing', identifier, '('",
			"expecting: 'true', 'false', 'null', not, 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'sqrt', 'log', 'exp', 'random', 'round', 'abs', 'floor', 'ceil', 'read()', 'readInt()', 'readDouble()', 'readString()', 'readChar()', 'isEOF()', identifier, stringliteral, charliteral, '(', '+', '++', '-', '--', intnumber, fpnumber",
			"expecting: identifier, '(', '[', bracket pair, dot, '<', '='",
			"expecting: EOF",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', 'print', 'println', 'if', 'while', 'return', 'switch', 'break', 'for', 'assert', 'arraycopy', 'drawBox', 'drawTriangle', 'drawEllipse', 'drawLine', 'drawString', 'clear()', 'setColour', 'setBGColour', 'fill', identifier, '}', EOF",
			"expecting: identifier, bracket pair, '<'",
			"expecting: dot, '='",
			"expecting: 'to', 'step', and, or, 'xor', '(', ')', '{', '}', '[', ']', ';', ':', ',', dot, '+', '++', '-', '--', '*', '/', '^', '%', '<', '<=', '>', '>=', '==', '!=', '='",
			"expecting: '{'",
			"expecting: 'new', 'true', 'false', 'null', not, 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'sqrt', 'log', 'exp', 'random', 'round', 'abs', 'floor', 'ceil', 'read()', 'readInt()', 'readDouble()', 'readString()', 'readChar()', 'isEOF()', identifier, stringliteral, charliteral, '(', '+', '++', '-', '--', intnumber, fpnumber",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ']', ';', ':', ',', '+', '++', '-', '--', '*', '/', '^', '%', '<', '<=', '>', '>=', '==', '!='",
			"expecting: 'true', 'false', 'null', 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'sqrt', 'log', 'exp', 'random', 'round', 'abs', 'floor', 'ceil', 'read()', 'readInt()', 'readDouble()', 'readString()', 'readChar()', 'isEOF()', identifier, stringliteral, charliteral, '(', intnumber, fpnumber",
			"expecting: 'to', 'step', ')', '{', '}', ';', ':', ','",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ';', ':', ',', '+', '-', '<', '<=', '>', '>=', '==', '!='",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ']', ';', ':', ',', '+', '-', '*', '/', '^', '%', '<', '<=', '>', '>=', '==', '!='",
			"expecting: 'to', 'step', or, 'xor', ')', '{', '}', ';', ':', ','",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ';', ':', ','",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ';', ':', ',', '==', '!='",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ';', ':', ',', '<', '<=', '>', '>=', '==', '!='",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', ']', ';', ':', ',', dot, '+', '++', '-', '--', '*', '/', '^', '%', '<', '<=', '>', '>=', '==', '!='",
			"expecting: dot",
			"expecting: '[', dot, '='",
			"expecting: or, 'xor', ';', ':'",
			"expecting: '}', EOF",
			"expecting: '(', ';', '='",
			"expecting: 'to', 'step', identifier, ')', '{', '}', bracket pair, ';', ':', ','",
			"expecting: identifier, bracket pair",
			"expecting: 'new', 'true', 'false', 'null', not, 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'sqrt', 'log', 'exp', 'random', 'round', 'abs', 'floor', 'ceil', 'read()', 'readInt()', 'readDouble()', 'readString()', 'readChar()', 'isEOF()', identifier, stringliteral, charliteral, '(', ')', ',', '+', '++', '-', '--', intnumber, fpnumber",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', '[', ']', bracket pair, ';', ':', ',', dot, '+', '++', '-', '--', '*', '/', '^', '%', '<', '<=', '>', '>=', '==', '!=', '='",
			"expecting: 'to', 'step', and, or, 'xor', ')', '{', '}', '[', ']', ';', ':', ',', dot, '+', '++', '-', '--', '*', '/', '^', '%', '<', '<=', '>', '>=', '==', '!=', '='",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', identifier, '}'",
			"expecting: '='",
			"expecting: ')'",
			"expecting: or, 'xor', ')'",
			"expecting: '['",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', 'print', 'println', 'if', 'while', 'return', 'switch', 'break', 'for', 'assert', 'arraycopy', 'drawBox', 'drawTriangle', 'drawEllipse', 'drawLine', 'drawString', 'clear()', 'setColour', 'setBGColour', 'fill', identifier, '}'",
			"expecting: '[', ',', dot",
			"expecting: ',', '+', '-'",
			"expecting: ','",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', identifier, ')'",
			"expecting: ',', '>'",
			"expecting: '>'",
			"expecting: ';', '='",
			"expecting: ')', ','",
			"expecting: ']', '+', '-'",
			"expecting: 'to', 'step', ')', '{', '}', '[', bracket pair, ';', ':', ','",
			"expecting: ')', '+', '-'",
			"expecting: '}'",
			"expecting: 'to'",
			"expecting: 'new', '{'",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', 'print', 'println', 'if', 'else', 'while', 'return', 'switch', 'break', 'for', 'assert', 'arraycopy', 'drawBox', 'drawTriangle', 'drawEllipse', 'drawLine', 'drawString', 'clear()', 'setColour', 'setBGColour', 'fill', identifier, '{', '}', EOF",
			"expecting: 'to', 'step', ')', '{', '}', bracket pair, ';', ':', ','",
			"expecting: 'case', 'default', '}'",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', 'print', 'println', 'if', 'else', 'while', 'return', 'switch', 'case', 'break', 'default', 'for', 'assert', 'arraycopy', 'drawBox', 'drawTriangle', 'drawEllipse', 'drawLine', 'drawString', 'clear()', 'setColour', 'setBGColour', 'fill', identifier, '{', '}', EOF",
			"expecting: ')', '[', dot",
			"expecting: 'new', 'true', 'false', 'null', not, 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'sqrt', 'log', 'exp', 'random', 'round', 'abs', 'floor', 'ceil', 'read()', 'readInt()', 'readDouble()', 'readString()', 'readChar()', 'isEOF()', identifier, stringliteral, charliteral, '(', '{', '+', '++', '-', '--', intnumber, fpnumber",
			"expecting: 'boolean', 'char', 'int', 'double', 'String', 'void', 'class', 'const', 'print', 'println', 'if', 'while', 'return', 'switch', 'break', 'for', 'assert', 'arraycopy', 'drawBox', 'drawTriangle', 'drawEllipse', 'drawLine', 'drawString', 'clear()', 'setColour', 'setBGColour', 'fill', identifier, '{', '}', EOF",
			"expecting: ':'",
			"expecting: 'step', '{'",
			"expecting: '}', ','",
			"expecting: or, 'xor', ';'",
			"expecting: '}', ';', ','",
			"expecting: ')', ',', '+', '-'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 1, 1, 1, 1, 2, 3, 4, 4, 4, 4, 5, 4, 6, 7, 8, 4, 4, 4, 4, 4, 4, 6, 4, 4, 4, 9, 10, 11, 6, 11, 12, 1, 1, 1, 13, 14, 14, 14, 15, 1, 2, 16, 16, 8, 8, 3, 17, 17, 17, 8, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 17, 17, 17, 17, 17, 17, 14, 17, 17, 8, 11, 8, 18, 8, 18, 17, 17, 17, 17, 6, 19, 20, 21, 21, 17, 17, 17, 21, 21, 17, 17, 22, 23, 24, 25, 26, 16, 11, 2, 2, 15, 27, 28, 29, 2, 8, 8, 8, 8, 16, 11, 8, 8, 8, 30, 11, 31, 32, 3, 2, 33, 2, 16, 34, 8, 35, 36, 37, 38, 39, 39, 40, 40, 41, 21, 8, 8, 8, 8, 8, 8, 8, 8, 8, 39, 8, 8, 8, 8, 40, 21, 17, 21, 17, 11, 8, 8, 8, 8, 8, 8, 17, 17, 8, 8, 8, 8, 8, 8, 8, 8, 8, 39, 28, 28, 42, 11, 16, 11, 16, 6, 43, 39, 44, 45, 39, 39, 39, 45, 39, 44, 39, 40, 46, 11, 16, 6, 47, 48, 49, 31, 32, 14, 6, 50, 50, 51, 35, 11, 37, 37, 6, 6, 6, 15, 15, 52, 53, 53, 53, 53, 53, 53, 53, 53, 53, 17, 53, 53, 53, 53, 17, 21, 21, 21, 21, 21, 21, 23, 23, 24, 25, 25, 20, 20, 20, 20, 15, 16, 16, 54, 55, 6, 11, 2, 6, 8, 8, 6, 6, 6, 16, 6, 8, 6, 6, 15, 39, 50, 33, 6, 11, 3, 47, 47, 2, 11, 6, 46, 11, 56, 6, 11, 17, 16, 35, 11, 37, 11, 11, 11, 57, 11, 58, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 59, 11, 55, 6, 60, 16, 61, 11, 44, 44, 11, 11, 11, 45, 11, 44, 11, 11, 11, 15, 3, 50, 50, 50, 33, 47, 47, 11, 15, 39, 62, 6, 6, 11, 50, 63, 11, 16, 64, 11, 59, 15, 59, 16, 8, 65, 6, 8, 8, 16, 8, 11, 50, 50, 50, 11, 15, 66, 54, 66, 11, 64, 15, 59, 11, 59, 65, 67, 16, 15, 11, 44, 53, 39, 53, 11, 15, 66, 66, 68, 16, 66, 66, 15, 15, 8, 15, 8, 6, 66, 66, 66, 66, 39, 69, 11, 15,
        };*/
}
